/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c') && (t3->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst();
    rv->code = 'C';

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = cfg_allocz(sizeof(struct f_inst3));
    rv->lineno = ifs->lino;
    rv->code = P('m','l');
    rv->a1.p = t1;
    rv->a2.p = t2;
    INST3(rv).p = t3;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}


#line 684 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    NMA = 277,
    DEFINE = 278,
    ON = 279,
    OFF = 280,
    YES = 281,
    NO = 282,
    S = 283,
    MS = 284,
    US = 285,
    PORT = 286,
    LOG = 287,
    SYSLOG = 288,
    ALL = 289,
    DEBUG = 290,
    TRACE = 291,
    INFO = 292,
    REMOTE = 293,
    WARNING = 294,
    ERROR = 295,
    AUTH = 296,
    FATAL = 297,
    BUG = 298,
    STDERR = 299,
    SOFT = 300,
    TIMEFORMAT = 301,
    ISO = 302,
    OLD = 303,
    SHORT = 304,
    LONG = 305,
    BASE = 306,
    NAME = 307,
    CONFIRM = 308,
    UNDO = 309,
    CHECK = 310,
    TIMEOUT = 311,
    LATENCY = 312,
    LIMIT = 313,
    WATCHDOG = 314,
    CONFIGURE = 315,
    DOWN = 316,
    KERNEL = 317,
    PERSIST = 318,
    SCAN = 319,
    TIME = 320,
    LEARN = 321,
    DEVICE = 322,
    ROUTES = 323,
    GRACEFUL = 324,
    RESTART = 325,
    KRT_SOURCE = 326,
    KRT_METRIC = 327,
    MERGE = 328,
    PATHS = 329,
    TABLE = 330,
    METRIC = 331,
    KRT_PREFSRC = 332,
    KRT_REALM = 333,
    KRT_SCOPE = 334,
    KRT_MTU = 335,
    KRT_WINDOW = 336,
    KRT_RTT = 337,
    KRT_RTTVAR = 338,
    KRT_SSTRESH = 339,
    KRT_CWND = 340,
    KRT_ADVMSS = 341,
    KRT_REORDERING = 342,
    KRT_HOPLIMIT = 343,
    KRT_INITCWND = 344,
    KRT_RTO_MIN = 345,
    KRT_INITRWND = 346,
    KRT_QUICKACK = 347,
    KRT_LOCK_MTU = 348,
    KRT_LOCK_WINDOW = 349,
    KRT_LOCK_RTT = 350,
    KRT_LOCK_RTTVAR = 351,
    KRT_LOCK_SSTRESH = 352,
    KRT_LOCK_CWND = 353,
    KRT_LOCK_ADVMSS = 354,
    KRT_LOCK_REORDERING = 355,
    KRT_LOCK_HOPLIMIT = 356,
    KRT_LOCK_RTO_MIN = 357,
    KRT_FEATURE_ECN = 358,
    KRT_FEATURE_ALLFRAG = 359,
    ROUTER = 360,
    ID = 361,
    PROTOCOL = 362,
    TEMPLATE = 363,
    PREFERENCE = 364,
    DISABLED = 365,
    DIRECT = 366,
    INTERFACE = 367,
    IMPORT = 368,
    EXPORT = 369,
    FILTER = 370,
    NONE = 371,
    STATES = 372,
    FILTERS = 373,
    RECEIVE = 374,
    ACTION = 375,
    WARN = 376,
    BLOCK = 377,
    DISABLE = 378,
    KEEP = 379,
    FILTERED = 380,
    PASSWORD = 381,
    FROM = 382,
    PASSIVE = 383,
    TO = 384,
    EVENTS = 385,
    PACKETS = 386,
    PROTOCOLS = 387,
    INTERFACES = 388,
    ALGORITHM = 389,
    KEYED = 390,
    HMAC = 391,
    MD5 = 392,
    SHA1 = 393,
    SHA256 = 394,
    SHA384 = 395,
    SHA512 = 396,
    PRIMARY = 397,
    STATS = 398,
    COUNT = 399,
    FOR = 400,
    COMMANDS = 401,
    PREEXPORT = 402,
    NOEXPORT = 403,
    GENERATE = 404,
    ROA = 405,
    LISTEN = 406,
    BGP = 407,
    V6ONLY = 408,
    DUAL = 409,
    ADDRESS = 410,
    PASSWORDS = 411,
    DESCRIPTION = 412,
    SORTED = 413,
    RELOAD = 414,
    IN = 415,
    OUT = 416,
    MRTDUMP = 417,
    MESSAGES = 418,
    RESTRICT = 419,
    MEMORY = 420,
    IGP_METRIC = 421,
    CLASS = 422,
    DSCP = 423,
    WAIT = 424,
    MAX = 425,
    FLUSH = 426,
    AS = 427,
    SHOW = 428,
    STATUS = 429,
    SUMMARY = 430,
    ROUTE = 431,
    SYMBOLS = 432,
    ADD = 433,
    DELETE = 434,
    DUMP = 435,
    RESOURCES = 436,
    SOCKETS = 437,
    NEIGHBORS = 438,
    ATTRIBUTES = 439,
    EVAL = 440,
    ECHO = 441,
    ENABLE = 442,
    FUNCTION = 443,
    PRINT = 444,
    PRINTN = 445,
    UNSET = 446,
    RETURN = 447,
    ACCEPT = 448,
    REJECT = 449,
    QUITBIRD = 450,
    INT = 451,
    BOOL = 452,
    IP = 453,
    PREFIX = 454,
    PAIR = 455,
    QUAD = 456,
    EC = 457,
    LC = 458,
    SET = 459,
    STRING = 460,
    BGPMASK = 461,
    BGPPATH = 462,
    CLIST = 463,
    ECLIST = 464,
    LCLIST = 465,
    IF = 466,
    THEN = 467,
    ELSE = 468,
    CASE = 469,
    TRUE = 470,
    FALSE = 471,
    RT = 472,
    RO = 473,
    UNKNOWN = 474,
    GENERIC = 475,
    GW = 476,
    NET = 477,
    MASK = 478,
    PROTO = 479,
    SOURCE = 480,
    SCOPE = 481,
    CAST = 482,
    DEST = 483,
    IFNAME = 484,
    IFINDEX = 485,
    LEN = 486,
    DEFINED = 487,
    CONTAINS = 488,
    RESET = 489,
    PREPEND = 490,
    FIRST = 491,
    LAST = 492,
    LAST_NONAGGREGATED = 493,
    MATCH = 494,
    ROA_CHECK = 495,
    EMPTY = 496,
    WHERE = 497,
    BFD = 498,
    MIN = 499,
    IDLE = 500,
    RX = 501,
    TX = 502,
    INTERVAL = 503,
    MULTIPLIER = 504,
    MULTIHOP = 505,
    NEIGHBOR = 506,
    DEV = 507,
    LOCAL = 508,
    AUTHENTICATION = 509,
    SIMPLE = 510,
    METICULOUS = 511,
    SESSIONS = 512,
    HOLD = 513,
    CONNECT = 514,
    RETRY = 515,
    KEEPALIVE = 516,
    STARTUP = 517,
    VIA = 518,
    NEXT = 519,
    HOP = 520,
    SELF = 521,
    DEFAULT = 522,
    PATH = 523,
    START = 524,
    DELAY = 525,
    FORGET = 526,
    AFTER = 527,
    BGP_PATH = 528,
    BGP_LOCAL_PREF = 529,
    BGP_MED = 530,
    BGP_ORIGIN = 531,
    BGP_NEXT_HOP = 532,
    BGP_ATOMIC_AGGR = 533,
    BGP_AGGREGATOR = 534,
    BGP_COMMUNITY = 535,
    BGP_EXT_COMMUNITY = 536,
    RR = 537,
    RS = 538,
    CLIENT = 539,
    CLUSTER = 540,
    AS4 = 541,
    ADVERTISE = 542,
    IPV4 = 543,
    CAPABILITIES = 544,
    PREFER = 545,
    OLDER = 546,
    MISSING = 547,
    LLADDR = 548,
    DROP = 549,
    IGNORE = 550,
    REFRESH = 551,
    INTERPRET = 552,
    COMMUNITIES = 553,
    BGP_ORIGINATOR_ID = 554,
    BGP_CLUSTER_LIST = 555,
    IGP = 556,
    GATEWAY = 557,
    RECURSIVE = 558,
    MED = 559,
    TTL = 560,
    SECURITY = 561,
    DETERMINISTIC = 562,
    SECONDARY = 563,
    ALLOW = 564,
    AWARE = 565,
    LINK = 566,
    EXTENDED = 567,
    SETKEY = 568,
    BGP_LARGE_COMMUNITY = 569,
    OSPF = 570,
    AREA = 571,
    OSPF_METRIC1 = 572,
    OSPF_METRIC2 = 573,
    OSPF_TAG = 574,
    OSPF_ROUTER_ID = 575,
    RFC1583COMPAT = 576,
    STUB = 577,
    TICK = 578,
    COST = 579,
    COST2 = 580,
    RETRANSMIT = 581,
    HELLO = 582,
    TRANSMIT = 583,
    PRIORITY = 584,
    DEAD = 585,
    TYPE = 586,
    BROADCAST = 587,
    BCAST = 588,
    NONBROADCAST = 589,
    NBMA = 590,
    POINTOPOINT = 591,
    PTP = 592,
    POINTOMULTIPOINT = 593,
    PTMP = 594,
    STRICT = 595,
    CRYPTOGRAPHIC = 596,
    ELIGIBLE = 597,
    POLL = 598,
    NETWORKS = 599,
    HIDDEN = 600,
    VIRTUAL = 601,
    ONLY = 602,
    BUFFER = 603,
    LARGE = 604,
    NORMAL = 605,
    STUBNET = 606,
    TAG = 607,
    EXTERNAL = 608,
    LSADB = 609,
    ECMP = 610,
    WEIGHT = 611,
    NSSA = 612,
    TRANSLATOR = 613,
    STABILITY = 614,
    GLOBAL = 615,
    LSID = 616,
    INSTANCE = 617,
    REAL = 618,
    NETMASK = 619,
    LENGTH = 620,
    LSA = 621,
    SUPPRESSION = 622,
    TOPOLOGY = 623,
    STATE = 624,
    PIPE = 625,
    PEER = 626,
    MODE = 627,
    OPAQUE = 628,
    TRANSPARENT = 629,
    RIP = 630,
    INFINITY = 631,
    UPDATE = 632,
    GARBAGE = 633,
    MULTICAST = 634,
    VERSION = 635,
    SPLIT = 636,
    HORIZON = 637,
    POISON = 638,
    REVERSE = 639,
    ZERO = 640,
    PLAINTEXT = 641,
    RIP_METRIC = 642,
    RIP_TAG = 643,
    STATIC = 644,
    PROHIBIT = 645,
    MULTIPATH = 646,
    BLACKHOLE = 647,
    UNREACHABLE = 648
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 613 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 1145 "cf-parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1162 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  70
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3507

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  415
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  269
/* YYNRULES -- Number of rules.  */
#define YYNRULES  953
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1811

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   648

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,    31,     2,     2,
     406,   407,    29,    27,   411,    28,    33,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   408,   405,
      23,    22,    24,   412,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   413,     2,   414,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   409,     2,   410,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    26,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   806,   806,   807,   810,   812,   820,   829,   830,   831,
     838,   839,   840,   848,   849,   850,   851,   852,   853,   859,
     860,   867,   868,   872,   879,   880,   884,   888,   895,   903,
     904,   911,   912,   918,   927,   928,   932,   937,   938,   942,
     943,   947,   948,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   966,   967,   977,   978,   979,   980,   983,   984,
     985,   986,   987,   988,   992,   998,   999,  1000,  1001,  1009,
    1012,  1019,  1022,  1025,  1028,  1032,  1033,  1037,  1038,  1039,
    1047,  1052,  1053,  1057,  1058,  1062,  1069,  1070,  1071,  1083,
    1088,  1092,  1106,  1107,  1121,  1122,  1126,  1127,  1128,  1129,
    1136,  1150,  1152,  1154,  1158,  1159,  1160,  1161,  1166,  1172,
    1173,  1177,  1185,  1189,  1191,  1197,  1198,  1205,  1206,  1210,
    1216,  1220,  1229,  1238,  1240,  1244,  1245,  1246,  1247,  1248,
    1249,  1250,  1251,  1252,  1253,  1254,  1255,  1259,  1260,  1261,
    1262,  1266,  1267,  1268,  1269,  1270,  1274,  1280,  1284,  1292,
    1293,  1301,  1309,  1310,  1311,  1315,  1316,  1320,  1325,  1326,
    1330,  1332,  1340,  1344,  1345,  1351,  1358,  1359,  1360,  1361,
    1365,  1373,  1379,  1380,  1381,  1385,  1386,  1390,  1391,  1392,
    1393,  1394,  1395,  1401,  1402,  1403,  1407,  1408,  1412,  1413,
    1419,  1420,  1423,  1425,  1429,  1430,  1434,  1454,  1455,  1456,
    1457,  1458,  1459,  1460,  1461,  1462,  1466,  1467,  1468,  1469,
    1470,  1471,  1472,  1473,  1474,  1475,  1481,  1484,  1487,  1490,
    1494,  1495,  1498,  1501,  1505,  1509,  1514,  1520,  1527,  1532,
    1537,  1542,  1546,  1550,  1554,  1563,  1571,  1575,  1582,  1583,
    1584,  1589,  1593,  1600,  1607,  1611,  1619,  1620,  1621,  1626,
    1630,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1644,  1649,
    1657,  1664,  1671,  1679,  1681,  1683,  1685,  1687,  1689,  1691,
    1693,  1696,  1700,  1706,  1707,  1708,  1712,  1713,  1719,  1721,
    1723,  1725,  1727,  1729,  1733,  1737,  1740,  1744,  1745,  1746,
    1750,  1751,  1752,  1760,  1760,  1770,  1774,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,
    1788,  1810,  1821,  1822,  1829,  1830,  1837,  1846,  1850,  1854,
    1878,  1879,  1883,  1896,  1896,  1912,  1913,  1916,  1917,  1921,
    1924,  1933,  1946,  1947,  1948,  1949,  1950,  1954,  1962,  1963,
    1964,  1965,  1966,  1970,  1973,  1974,  1975,  1976,  1977,  1978,
    1979,  1980,  1981,  1982,  1987,  1988,  1989,  1990,  1994,  1995,
    1996,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2012,
    2013,  2014,  2015,  2016,  2020,  2021,  2022,  2023,  2024,  2028,
    2029,  2033,  2034,  2038,  2045,  2046,  2047,  2048,  2055,  2056,
    2059,  2060,  2067,  2079,  2080,  2084,  2085,  2089,  2090,  2091,
    2092,  2093,  2094,  2098,  2099,  2100,  2104,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2112,  2113,  2114,  2118,  2119,  2120,
    2130,  2134,  2157,  2171,  2172,  2173,  2174,  2175,  2176,  2177,
    2178,  2179,  2180,  2184,  2185,  2186,  2187,  2188,  2189,  2190,
    2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,  2199,  2200,
    2202,  2203,  2204,  2206,  2208,  2210,  2212,  2213,  2214,  2215,
    2216,  2217,  2227,  2228,  2229,  2230,  2231,  2232,  2233,  2234,
    2236,  2237,  2242,  2265,  2266,  2267,  2268,  2269,  2270,  2274,
    2277,  2278,  2279,  2287,  2294,  2303,  2304,  2308,  2314,  2324,
    2333,  2339,  2344,  2351,  2356,  2362,  2363,  2364,  2372,  2373,
    2374,  2375,  2376,  2382,  2394,  2395,  2396,  2397,  2400,  2402,
    2406,  2410,  2424,  2444,  2445,  2446,  2447,  2448,  2449,  2450,
    2451,  2455,  2456,  2457,  2458,  2459,  2460,  2463,  2465,  2468,
    2470,  2474,  2477,  2482,  2483,  2484,  2488,  2489,  2493,  2494,
    2497,  2516,  2522,  2547,  2549,  2550,  2554,  2555,  2556,  2557,
    2558,  2559,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,
    2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,
    2583,  2584,  2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,
    2593,  2594,  2595,  2596,  2597,  2598,  2599,  2600,  2601,  2602,
    2603,  2609,  2610,  2611,  2612,  2613,  2614,  2615,  2616,  2617,
    2618,  2619,  2620,  2621,  2622,  2623,  2634,  2644,  2645,  2649,
    2650,  2651,  2652,  2653,  2654,  2655,  2656,  2657,  2660,  2675,
    2678,  2680,  2684,  2685,  2686,  2687,  2688,  2689,  2690,  2691,
    2692,  2693,  2693,  2694,  2694,  2695,  2696,  2697,  2701,  2702,
    2706,  2714,  2716,  2720,  2721,  2722,  2726,  2727,  2730,  2732,
    2735,  2736,  2737,  2738,  2739,  2740,  2741,  2742,  2743,  2744,
    2745,  2748,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,
    2776,  2777,  2778,  2779,  2780,  2781,  2782,  2783,  2784,  2785,
    2786,  2787,  2788,  2789,  2790,  2791,  2792,  2793,  2794,  2795,
    2796,  2797,  2798,  2799,  2800,  2801,  2802,  2803,  2804,  2805,
    2806,  2809,  2811,  2814,  2816,  2825,  2827,  2828,  2831,  2833,
    2837,  2838,  2841,  2851,  2872,  2874,  2878,  2878,  2881,  2883,
    2886,  2888,  2892,  2896,  2897,  2902,  2905,  2908,  2913,  2916,
    2921,  2924,  2928,  2932,  2935,  2936,  2937,  2938,  2939,  2940,
    2941,  2942,  2948,  2955,  2956,  2957,  2962,  2963,  2969,  2982,
    2983,  2984,  2985,  2986,  2989,  2991,  2995,  2999,  3022,  3052,
    3053,  3054,  3055,  3056,  3057,  3058,  3062,  3063,  3064,  3065,
    3066,  3067,  3068,  3069,  3070,  3071,  3072,  3073,  3074,  3075,
    3076,  3077,  3078,  3079,  3083,  3084,  3085,  3086,  3089,  3091,
    3094,  3096,  3100,  3106,  3109,  3116,  3123,  3124,  3125,  3126,
    3127,  3130,  3140,  3149,  3153,  3159,  3160,  3164,  3169,  3175,
    3178,  3183,  3184,  3185,  3186,  3187,  3191,  3192,  3195,  3197,
    3200,  3202,  3206,  3213,  3213,  3213,  3213,  3213,  3213,  3213,
    3213,  3213,  3213,  3213,  3213,  3213,  3213,  3213,  3213,  3214,
    3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,
    3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,
    3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,
    3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,
    3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,  3215,  3215,
    3215,  3215,  3215,  3215,  3215,  3215,  3215,  3216,  3216,  3216,
    3216,  3217,  3217,  3217,  3218,  3218,  3218,  3218,  3218,  3218,
    3218,  3218,  3218,  3218,  3218,  3218,  3218,  3218,  3218,  3218,
    3218,  3218,  3218,  3218,  3218,  3218,  3218,  3218,  3218,  3218,
    3218,  3218,  3218,  3218,  3218,  3219,  3219,  3220,  3221,  3222,
    3223,  3224,  3225,  3226,  3227,  3228,  3229,  3230,  3231,  3231,
    3231,  3231,  3231,  3231
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG",
  "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR",
  "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD",
  "SHORT", "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "LATENCY", "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART",
  "KRT_SOURCE", "KRT_METRIC", "MERGE", "PATHS", "TABLE", "METRIC",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER",
  "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "STATES", "FILTERS",
  "RECEIVE", "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED",
  "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "INTERFACES", "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1", "SHA256",
  "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS",
  "PREEXPORT", "NOEXPORT", "GENERATE", "ROA", "LISTEN", "BGP", "V6ONLY",
  "DUAL", "ADDRESS", "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN",
  "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC",
  "CLASS", "DSCP", "WAIT", "MAX", "FLUSH", "AS", "SHOW", "STATUS",
  "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP", "RESOURCES",
  "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO", "ENABLE",
  "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT",
  "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD", "EC", "LC",
  "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST", "LCLIST", "IF",
  "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO", "UNKNOWN",
  "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE", "CAST",
  "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS", "RESET",
  "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH", "ROA_CHECK",
  "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX", "INTERVAL",
  "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL", "AUTHENTICATION",
  "SIMPLE", "METICULOUS", "SESSIONS", "HOLD", "CONNECT", "RETRY",
  "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH",
  "START", "DELAY", "FORGET", "AFTER", "BGP_PATH", "BGP_LOCAL_PREF",
  "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP", "BGP_ATOMIC_AGGR",
  "BGP_AGGREGATOR", "BGP_COMMUNITY", "BGP_EXT_COMMUNITY", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "IPV4", "CAPABILITIES",
  "PREFER", "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH",
  "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST",
  "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL", "SECURITY", "DETERMINISTIC",
  "SECONDARY", "ALLOW", "AWARE", "LINK", "EXTENDED", "SETKEY",
  "BGP_LARGE_COMMUNITY", "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2",
  "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB", "TICK", "COST",
  "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD", "TYPE",
  "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE",
  "POLL", "NETWORKS", "HIDDEN", "VIRTUAL", "ONLY", "BUFFER", "LARGE",
  "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP", "WEIGHT",
  "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL", "LSID", "INSTANCE", "REAL",
  "NETMASK", "LENGTH", "LSA", "SUPPRESSION", "TOPOLOGY", "STATE", "PIPE",
  "PEER", "MODE", "OPAQUE", "TRANSPARENT", "RIP", "INFINITY", "UPDATE",
  "GARBAGE", "MULTICAST", "VERSION", "SPLIT", "HORIZON", "POISON",
  "REVERSE", "ZERO", "PLAINTEXT", "RIP_METRIC", "RIP_TAG", "STATIC",
  "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE", "';'", "'('", "')'",
  "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept", "config",
  "conf_entries", "definition", "expr", "expr_us", "bool", "ipa",
  "ipa_scope", "prefix", "prefix_or_ipa", "pxlen", "datetime", "text",
  "text_or_none", "log_config", "syslog_name", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "timeformat_which",
  "timeformat_spec", "timeformat_base", "debug_unix", "cmd_CONFIGURE",
  "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO",
  "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_mp_limit", "kern_item", "kif_proto_start",
  "kif_item", "kern_sys_item", "rtrid", "idval", "listen", "listen_opts",
  "listen_opt", "gr_opts", "tab_sorted", "newtab", "roa_table_start",
  "roa_table_opts", "roa_table", "proto_start", "proto_name", "proto_item",
  "imexport", "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optsym", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "export_mode",
  "cmd_SHOW_ROA", "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args",
  "roa_table_arg", "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO",
  "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART",
  "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG",
  "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def",
  "$@1", "filter_eval", "type", "one_decl", "decls", "declsn",
  "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "cmds_int", "block",
  "fipa", "set_atom", "switch_atom", "cnum", "pair_item", "ec_kind",
  "ec_item", "lc_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bfd_proto_start", "bfd_proto_item",
  "bfd_proto_opts", "bfd_proto", "bfd_iface_start", "bfd_iface_finish",
  "bfd_iface_item", "bfd_auth_type", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_nbr_opts", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_patt_list", "$@5",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_proto_start",
  "rip_proto_item", "rip_proto_opts", "rip_proto", "rip_iface_start",
  "rip_iface_finish", "rip_iface_item", "rip_auth", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface", "cmd_SHOW_RIP_INTERFACES",
  "cmd_SHOW_RIP_NEIGHBORS", "static_proto_start", "static_proto",
  "stat_route0", "stat_multipath1", "stat_multipath", "stat_route",
  "stat_route_item", "stat_route_opts", "stat_route_opt_list",
  "cmd_SHOW_STATIC", "conf", "cli_cmd", "proto", "kern_proto", "kif_proto",
  "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,   277,    43,    45,    42,
      47,    37,    33,    46,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,    59,    40,    41,    58,   123,
     125,    44,    63,    91,    93
};
# endif

#define YYPACT_NINF -1367

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1367)))

#define YYTABLE_NINF -486

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-486)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      88,  3305,   103,   921,   558,   873,    62,   558,   558,   803,
     558,   171,   211,  1144,   218,   231,  1074,  1813,    68,   558,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367,   180,   461,   186,   410,   105,   132,   207,   282,
   -1367, -1367,   393,   333,   320,   219,  1813,   491, -1367, -1367,
   -1367, -1367, -1367, -1367,    51,    51, -1367, -1367, -1367, -1367,
     138, -1367,   790, -1367,    51,  2603, -1367, -1367, -1367,    51,
   -1367,    51,  3055,    51,  2710,    51,  1617,    51, -1367,    51,
    2585, -1367, -1367,  2523,  3097, -1367, -1367, -1367,    69, -1367,
     532,   562,   571,   532,   509, -1367,   589,   598,   558,   558,
     622,    70, -1367,   508,   655,   113, -1367,   625,   636, -1367,
   -1367,   412,   146,    57,   664,   443,   443,   705,   729,   735,
     737,   742,   749,   783,   785,    52, -1367, -1367, -1367,   659,
     401, -1367,   560,    81,    26,  1813, -1367,   404,   431,   439,
   -1367, -1367,   441,   456,   463,  1362,   169, -1367, -1367, -1367,
   -1367, -1367,  2761, -1367,  3006, -1367, -1367,  2041,   852,   815,
     798, -1367, -1367,   814, -1367, -1367,   -12,   109,    69,   212,
   -1367, -1367, -1367, -1367,   300,   478,   212,   212,   716,   745,
     108, -1367,   892, -1367,    70,   487,  3103, -1367,   780,   907,
     519,   527, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367,   531,    69,   620,   925,   829,   212,    63, -1367,
     131,   537,   894,   686,    70, -1367,   556,   567,   577,   584,
      50,   680,   927,   604,   992,   730,   686,    63,   945,   934,
    -126,   851,    63,    61,   443,   148,   947,   165,   949,   765,
     760,   429,   951,   761,   425,   753,   755,    63,   754,   751,
     748,   684,   -43,   972,   743,   746,    63,   811,    63, -1367,
     675,   687,   741,   162,    63,   990,   212,    63,   993, -1367,
   -1367,   704,   702, -1367,   706,  1028,   407, -1367,   713,   710,
     714,   799,   443,  1036, -1367,   719,   376,   717,  1039,    63,
    1052,    63,  1050,  1060,  1045,   212, -1367,   747,   752,   757,
    1078,  1139, -1367,   758,   759, -1367, -1367,   470,  1164,   509,
   -1367, -1367,  1167,   212,  1170, -1367, -1367,  1171,  1174, -1367,
   -1367, -1367,   209,  1175,  1160,  1178, -1367, -1367,   870,  1179,
   -1367,  1180,   353, -1367, -1367,  2649,   932,   664, -1367,   664,
     664, -1367,   336,   341,  1188,   664,   664,  1189, -1367, -1367,
      -2,   999,  1012, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367,    29, -1367,    52,  1813,    52,    52,  1181, -1367,  1193,
    1478,  1182,    84,  1166,    26,    26,  1183,  1186,  1813,  1813,
    1813,  1813,  1813,  1192, -1367, -1367,  1197, -1367,   810,   110,
   -1367, -1367, -1367, -1367,  1049, -1367,  1207, -1367, -1367, -1367,
   -1367,  -144,     7, -1367,   -34, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,  1813,  1813,
    1813,  1813,  1813,  1813,  1813,  1813,  1813,  1813,  1813,  1813,
    1813,  1813,   602, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367,   414, -1367, -1367,  1219, -1367,  1813,   686, -1367,
   -1367,  2041,   818, -1367, -1367, -1367, -1367, -1367, -1367,   212,
    1813, -1367, -1367, -1367, -1367,   212,   847,   888, -1367,   629,
   -1367, -1367,   212, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
    1813,   821,  3085, -1367,   230,   822, -1367,   824,  1209, -1367,
   -1367, -1367,  -112, -1367, -1367,    63, -1367, -1367,   162, -1367,
   -1367, -1367, -1367,   133,  1689, -1367,  1095,  1813, -1367, -1367,
     133, -1367,   133, -1367, -1367, -1367, -1367, -1367, -1367,  1156,
    1157,    63,   287, -1367,   835,  1195,   839,   844,   212,   338,
     952,    63,  1076,   443,   855, -1367,   856,  1226,    65,   212,
    1081,   212,  1194,  1205,   212,  1206,    38,   212,   212,    63,
    1208,   866,  1169,   878,    63,   884,    63,   430,    63,   925,
      63,   885,   886,    63,    63,    63,   889,  1110,   897, -1367,
   -1367,    63, -1367, -1367,    63, -1367,  1234,   212, -1367, -1367,
   -1367,  1285,   901,   906, -1367, -1367, -1367,    63, -1367,   925,
   -1367, -1367,   736, -1367,   443, -1367,  1040, -1367, -1367, -1367,
     908,   212, -1367,   212, -1367,    63,    63,    63, -1367, -1367,
   -1367, -1367,   212, -1367,   443, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367,   522, -1367, -1367,  1312, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367,   546, -1367, -1367, -1367, -1367,  1315,
   -1367, -1367, -1367,  1303, -1367, -1367,  1308,   443, -1367, -1367,
    1305,  1306, -1367,  1689, -1367, -1367, -1367, -1367,   443, -1367,
   -1367, -1367,  1309, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367,  1324,  1310,  1310,   588,   664,  1310,   664,  1310,
   -1367,  1310,  1310, -1367,   212,   443, -1367,  1318,  1319,  1320,
   -1367, -1367,  1062, -1367, -1367, -1367, -1367,   534, -1367,   929,
   -1367,  1089,  1316, -1367, -1367, -1367, -1367,   632,   701,   739,
    1177,   773,   101, -1367,  1813, -1367,  1813,   935,     4,   936,
    1918,   204,   245, -1367, -1367, -1367,  1330,  1332, -1367,  1982,
    1982,  1982,  2722,  2722,  1982,  1982,  1982,  1982,  1982,   775,
     775,  1186,  1186, -1367,   946, -1367, -1367, -1367, -1367, -1367,
    2041, -1367,  1401, -1367,   555, -1367, -1367,  1950,  1334, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367,   954, -1367,   955,  2043,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367,    92,   966,   948, -1367, -1367,
     212, -1367, -1367,   443, -1367, -1367, -1367,  2732,  3085, -1367,
     443, -1367,   967, -1367,  1327, -1367,   962, -1367,  1243, -1367,
   -1367, -1367, -1367,    63,  3103, -1367, -1367,  2502,   212,   212,
     971,   212,   978,   979, -1367,    63, -1367, -1367,   980,   981,
     982,   983,    63,   986,    63,   988, -1367, -1367,  1376, -1367,
     212,   212, -1367,   991,   212,   994,   212,   212,   995,   212,
    1000,  1001,  1003,  1010,  1013,   212, -1367,   162, -1367,  1014,
   -1367,  1016,  1017,  1027,  1032,  1033,  1037,  1041, -1367, -1367,
    1042,  1043,  1044, -1367,   286, -1367, -1367, -1367,   212, -1367,
     635,  1047, -1367, -1367,  2979,  1051,  1054, -1367,  1226, -1367,
     443,  -124,  1040,   943, -1367, -1367, -1367, -1367, -1367,  1328,
   -1367,    -2, -1367, -1367, -1367,   470, -1367, -1367,   209, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
    1414,  1430, -1367, -1367,   162, -1367, -1367,   162,  1389, -1367,
     162,  1310,  1438,  1310,  1441,  1442,  1451, -1367, -1367,  1274,
    1281,    52, -1367,  1813, -1367,  1437,  1440,  1813,  1813,  1813,
   -1367,  1813, -1367,  1813,   805,   182,  1550,  1813,  1610,  1813,
   -1367, -1367,  1813, -1367, -1367,  1065,   659, -1367,  1813, -1367,
   -1367, -1367, -1367, -1367, -1367,   962, -1367, -1367, -1367, -1367,
    3085,   933, -1367, -1367, -1367,  1066,  1070, -1367,  1297, -1367,
   -1367,   961, -1367,   553, -1367, -1367, -1367, -1367,   443, -1367,
   -1367,  1075,  1068,  1084, -1367,  1085, -1367, -1367,  1087, -1367,
   -1367, -1367, -1367,  1094, -1367,  1096, -1367, -1367,   114, -1367,
   -1367, -1367,  1097, -1367,  1098,  1099, -1367,  1102, -1367, -1367,
   -1367, -1367, -1367,  1104,  1106, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367,  1107, -1367, -1367,
      63,   331,    53, -1367,  1159,   443, -1367, -1367,   199, -1367,
    1108, -1367,  1127, -1367, -1367,    63,   212, -1367, -1367,  1109,
   -1367, -1367, -1367,  1226,    63,   212,  -124,     1, -1367,  1461,
   -1367, -1367,  1113,  1813, -1367, -1367, -1367,  1813,  1813,    63,
   -1367,  2761,  1111,  1628, -1367, -1367,   212, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367,  1512, -1367,  1517, -1367,
   -1367, -1367,  1506,  1507, -1367, -1367,  1495, -1367,  2074,  2100,
    2134,  2160,   831,  1813, -1367,  1813,   241,    23,  3103,  1114,
     291,     3,  1115,  1918,  1509,  2205, -1367,  1123,    78, -1367,
    3085, -1367,  1519,   443, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367,  1126, -1367,    56, -1367, -1367,   212, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367,   212,   212,    63,   212, -1367,
    1128,   162, -1367, -1367,  1129,  1130,   212, -1367, -1367,   212,
    1131, -1367, -1367,  1472, -1367, -1367, -1367, -1367, -1367,  1813,
    1478,  1813, -1367,  2443,  2789,   876,  1137,  1523,   391, -1367,
    3103,  1135,  1142, -1367, -1367, -1367,   508,   508,  1520, -1367,
   -1367, -1367, -1367,  1813,  2231,  2257, -1367,  1521,  1813, -1367,
    1668, -1367,  1524,  1813,  1542,  1742,  1792,  1147, -1367, -1367,
   -1367, -1367,  1371, -1367,   962,  1126, -1367, -1367,  1539,   686,
    1296,  1168,   962,  1152, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367,  1155,   212,  2475,  1165,  2501,
    2877, -1367,   827, -1367, -1367,  1813,  1813,   507,  1628, -1367,
    1568,  1572, -1367,  2283, -1367, -1367,  1176,  1187,   326,    40,
    1190,   335,  1200,  1202,    43,  1203,    45, -1367,  1561, -1367,
     848, -1367, -1367, -1367,   443,  1325, -1367,  1127, -1367, -1367,
      41,   -44,    44,   960, -1367, -1367, -1367, -1367, -1367, -1367,
    1204,   933,  1357, -1367,    39,  2527,  2553,  1210,  1211,  1218,
    1225,  1191, -1367, -1367, -1367, -1367, -1367, -1367, -1367,  1556,
    1813, -1367, -1367, -1367,  1558,  1813, -1367,  1813,  1588, -1367,
    1813, -1367,  1227, -1367,   686,    63,  1224,   712,  1341,   212,
     212,   317, -1367, -1367, -1367,  1241,  1230, -1367,    63, -1367,
   -1367,  3089, -1367, -1367, -1367,    15,    63,   212,    63, -1367,
    1246, -1367,   212,   -42,   212,   212,  1331,   134, -1367, -1367,
    1247,  2526, -1367,  1248,  1244,   827,   145, -1367, -1367, -1367,
    1049, -1367, -1367,  1593, -1367, -1367, -1367, -1367,    60, -1367,
   -1367,  1813,  1813,  1813,  1813, -1367,  1250,  1254,  1255,  1258,
    1264,  1266,  1268, -1367, -1367, -1367,  1477,  1356,  1420,  1421,
   -1367, -1367, -1367,   828, -1367,  1527, -1367,  1103, -1367, -1367,
    1367,   212,  1282,    63,  1333,    97,   -25,  1373,    63,  1317,
      63,   212,   212,   212,  1418,   212,   210,  1019,  1326,  1361,
     212,  1343,  1369, -1367, -1367,  1311, -1367,   212,  1313, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,   212,
     212, -1367, -1367,   212,   126,  1638,   212,    63,   443,    63,
    1360,   190,   -84,  1403,  1355,    -1,  1647,  1649,   289,  1335,
    1336, -1367, -1367,  1321, -1367, -1367, -1367, -1367,  2309,   270,
     145,   278,  2336,  2362,  2388,  2414, -1367, -1367, -1367,  1813,
   -1367,  1813, -1367,  1322,  1329,   212,   212,   212, -1367, -1367,
     834,   212,  1707,  1707,   842,    19,   389,  1339,    63, -1367,
   -1367, -1367,   311,   212,   212,   212,   212, -1367, -1367, -1367,
   -1367,   535, -1367,  1365, -1367, -1367, -1367, -1367,   212, -1367,
     212, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
      63,    63, -1367,   212,    63, -1367, -1367, -1367, -1367, -1367,
   -1367,    63,    63,   212, -1367, -1367, -1367, -1367,   212,   212,
     212, -1367, -1367, -1367, -1367, -1367, -1367,   594,   212, -1367,
   -1367,   212,   212,    63, -1367,    63,    63, -1367, -1367,  1813,
   -1367, -1367, -1367,  1340,  1345,  1346,  1347,  1337,  1342, -1367,
    1477, -1367, -1367, -1367, -1367, -1367,  1351, -1367,  1358,  1359,
     723,   950,  1368,  1707,  1707,  1707,  1707, -1367, -1367,    55,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367,  1377, -1367,    63,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367,  1388, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
    2309, -1367, -1367, -1367, -1367, -1367,  1813, -1367,  1103,  1103,
    1103, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367,  1103,  1374,  1375,  1378,  1379, -1367,  1412, -1367, -1367,
   -1367, -1367,  1370, -1367, -1367, -1367, -1367,  1103,  1103,  1103,
    1103, -1367,  1381,  1813, -1367, -1367, -1367, -1367, -1367,  1380,
   -1367
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    75,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   420,     0,     0,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,     3,
       1,     2,     0,     0,     0,     0,     0,     0,     0,     0,
     117,   118,     0,     0,     0,     0,   420,     0,   823,   824,
     825,   826,   827,   828,   119,   119,   829,   830,   831,   832,
     115,   833,     0,   835,   119,   123,   836,   837,   838,   119,
     891,   119,   123,   119,   123,   119,   123,   119,   895,   119,
     123,     5,   834,   123,   123,   287,   289,   288,     0,    76,
      75,     0,     0,    75,    77,    74,     0,     0,     0,     0,
       0,     0,   286,   258,   291,     0,   242,     0,     0,   225,
     250,     0,   221,     0,   221,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   402,   406,   415,   412,   331,
     422,   409,     0,     0,   405,   420,   453,     0,     0,     0,
     407,   408,     0,     0,     0,   420,     0,   410,   411,   416,
     451,   452,     0,   450,     0,   274,   273,     0,   276,     0,
       0,    30,    29,    35,    38,    36,     0,    18,     0,     0,
      57,    56,    55,    54,     0,     0,     0,     0,     0,   109,
       0,   293,     0,   102,     0,     0,   295,   323,   120,     0,
       0,     0,   113,    80,    89,   165,   542,   503,   606,   742,
     748,   795,     0,     0,     0,     0,     0,     0,    18,   170,
       0,     0,     0,     0,     0,   890,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,    18,     0,   543,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,    18,   892,
       0,     0,     0,     0,    18,     0,     0,    18,     0,   893,
     609,     0,     0,   617,     0,     0,     0,   894,     0,     0,
       0,     0,     0,     0,   896,     0,     0,   820,     0,    18,
       0,    18,     0,     0,     0,     0,   888,     0,     0,     0,
       0,    32,   889,     0,     0,   173,   172,     0,     0,    77,
      71,    72,     0,    78,     0,   280,   278,     0,     0,   281,
     184,   183,     0,     0,     0,     0,   290,   292,   291,     0,
     222,     0,   246,   217,   216,     0,     0,   221,   220,   221,
     221,   733,   221,   221,     0,   221,   221,     0,    19,    20,
       0,     0,     0,   269,   265,   270,   266,   263,   264,   267,
     268,   402,   422,   402,   420,   402,   402,     0,   393,     0,
     420,     0,     0,     0,   405,   405,     0,   448,   420,   420,
     420,   420,   420,     0,   354,   355,     0,   357,     0,     0,
     332,   335,   333,   337,   420,   334,   372,   369,   370,   371,
     379,     0,   384,   388,     0,   935,   904,   905,   906,   907,
     908,   909,   910,   911,   912,   913,   914,   915,   916,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,   927,
     928,   929,   930,   931,   932,   933,   423,   934,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   937,   940,   939,
     936,   938,   941,   942,   943,   946,   944,   945,   947,   948,
     949,   950,   951,   952,   953,   454,   455,   271,   420,   420,
     420,   420,   420,   420,   420,   420,   420,   420,   420,   420,
     420,   420,     0,    43,    44,    45,    46,    47,    48,    49,
      50,    51,     0,    41,   277,     0,   279,   420,     0,    37,
      39,     0,     0,     7,     9,    14,    16,    15,    17,     0,
     420,    13,    65,   149,   150,    58,     0,     0,    64,     0,
      67,    68,     0,   110,   111,    96,    98,    99,   100,   161,
     420,     0,   312,   112,     0,     0,    53,     0,     0,   121,
     897,   901,     0,   166,   126,    18,   148,   134,     0,   124,
     125,   151,   139,     0,   312,   140,     0,   420,   128,   138,
       0,   129,     0,   136,   127,   167,   168,   508,   546,     0,
       0,    18,    18,   558,     0,     0,     0,     0,     0,    18,
       0,    18,     0,     0,     0,   559,     0,    21,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    18,
       0,     0,     0,     0,    18,     0,    18,     0,    18,     0,
      18,     0,     0,    18,    18,    18,     0,     0,     0,   547,
     607,    18,   618,   610,    18,   615,   612,     0,   608,   620,
     743,     0,     0,     0,   744,   754,   796,    18,   801,     0,
     797,   812,     0,   811,     0,   815,     0,   813,   814,   818,
       0,     0,    83,     0,    85,    18,    18,    18,    93,   899,
     900,   898,     0,    31,     0,   903,   902,   178,   177,   179,
     181,   182,   180,     0,   175,   284,     0,    73,    79,    69,
     282,   283,   188,   189,     0,   186,   285,   259,   262,     0,
     218,   223,   241,     0,   248,   247,     0,     0,   224,   231,
       0,     0,   239,   312,   233,   232,   236,   237,     0,   238,
     240,   226,     0,   230,   249,   257,   251,   254,   255,   253,
     256,   252,     0,   724,   724,     0,   221,   724,   221,   724,
     725,   724,   724,   822,     0,     0,    23,     0,     0,     0,
     397,   399,     0,   400,   401,   395,   383,   483,   486,     0,
     462,     0,     0,   463,   403,   404,   396,     0,     0,     0,
       0,     0,     0,   356,   420,   433,   420,     0,     0,     0,
     343,     0,     0,   413,   385,   386,     0,     0,   414,   445,
     443,   441,   438,   439,   440,   442,   444,   446,   447,   434,
     435,   436,   437,   456,     0,   457,   459,   460,   461,   275,
       0,   272,     0,    34,     0,    33,    66,     0,     0,    60,
      61,    62,    63,    10,    11,    12,     0,   151,     0,     0,
      94,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,     0,     0,     0,   294,   316,
       0,   106,   107,     0,   101,   103,    52,     0,   312,   122,
       0,   116,     0,   135,   155,   158,   171,   147,   141,   131,
     317,   318,   137,    18,   319,   132,   130,   123,     0,     0,
       0,     0,     0,     0,   552,    18,   588,   591,     0,     0,
       0,     0,    18,     0,    18,     0,   605,   560,     0,   543,
       0,     0,   550,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   554,     0,   555,     0,
     586,     0,     0,     0,     0,     0,     0,     0,   566,   567,
       0,     0,     0,   593,     0,   589,   614,   611,     0,   616,
       0,     0,   746,   747,   123,     0,     0,   808,    21,   810,
       0,   805,   809,   420,   800,    92,    84,    86,    87,    81,
      90,    25,    24,    91,   174,     0,    70,   185,     0,   219,
     245,   244,   243,   228,   235,   229,   227,   234,   541,   723,
       0,     0,   732,   741,     0,   739,   736,     0,     0,   734,
       0,   724,     0,   724,     0,     0,     0,    26,    27,     0,
       0,   402,   394,   420,   472,     0,     0,   420,   420,   420,
     449,   420,   470,   420,     0,     0,   420,   420,   420,   420,
     336,   331,   420,   373,   380,     0,     0,   389,   420,    42,
       6,    40,     8,    59,   108,   162,    95,    97,   311,   310,
     312,   420,   105,   104,   321,   314,     0,   324,     0,   169,
     156,     0,   151,     0,   146,   133,   511,   511,     0,   510,
     504,     0,     0,     0,   604,     0,   600,   599,     0,   590,
     594,   595,   596,     0,   584,     0,   575,    22,     0,   544,
     545,   548,     0,   556,     0,     0,   579,     0,   562,   561,
     574,   573,   568,     0,     0,   587,   571,   563,   564,   565,
     592,   602,   570,   569,   603,   572,   597,     0,   613,   713,
      18,     0,    18,   631,     0,     0,   633,   623,    18,   619,
       0,   637,   714,   745,   757,    18,     0,   756,   749,     0,
     798,   799,   807,    21,    18,     0,   806,     0,   476,     0,
     477,   478,     0,   420,   474,   475,   473,   420,   420,    18,
     821,     0,     0,   420,   816,   819,     0,    88,   176,   187,
     727,   726,   740,   735,   737,   738,     0,   728,     0,   730,
     793,   794,     0,     0,   398,   484,     0,   464,     0,     0,
       0,     0,     0,   420,   417,   420,     0,     0,   343,     0,
       0,     0,     0,     0,     0,     0,   313,     0,   420,   327,
       0,   320,     0,   152,   153,   157,   159,   144,   142,   143,
     145,   151,   505,   529,   506,   533,   507,   509,     0,   580,
     601,   582,   583,   585,   551,   549,   578,   577,   557,   576,
     553,   598,   151,   636,   624,     0,     0,    18,     0,   622,
       0,     0,   640,   635,   639,     0,     0,   629,   621,     0,
     647,   151,   753,   750,   752,   755,   802,   804,   803,   420,
     420,   420,   420,     0,     0,     0,     0,     0,     0,   496,
     479,   481,     0,    82,   729,   731,   258,   258,     0,   469,
     467,   468,   466,   420,     0,     0,   352,     0,   420,   350,
     420,   346,     0,   420,   344,   420,   420,     0,   458,   322,
     328,   315,     0,   154,   160,   529,   527,   512,     0,     0,
     536,     0,   716,   720,   626,   627,   625,   628,   701,   661,
     641,   701,   630,   715,   648,   790,     0,     0,     0,     0,
       0,   490,   420,   390,   817,   420,   420,     0,   420,   495,
       0,     0,   465,     0,   418,   419,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   387,     0,   512,
       0,   532,   534,   535,     0,   538,   581,   714,   718,   722,
       0,     0,     0,   650,   788,   758,   751,   489,   421,   493,
       0,   420,   487,   329,     0,     0,     0,     0,     0,     0,
       0,     0,   482,   260,   261,   471,   367,   351,   349,     0,
     420,   347,   365,   345,     0,   420,   363,   420,   361,   360,
     420,   358,     0,   531,     0,    18,     0,     0,     0,     0,
       0,     0,   530,   520,   191,   195,     0,   537,    18,   540,
     717,     0,   632,   704,   702,   705,    18,     0,    18,   638,
       0,   634,     0,     0,     0,     0,     0,     0,   646,   660,
       0,     0,   792,     0,     0,   420,   420,   338,   342,   340,
     420,   497,   341,   377,   374,   375,   376,   381,     0,   492,
     491,   420,   420,   420,   420,   498,     0,     0,     0,     0,
       0,     0,     0,   114,   196,   518,   192,     0,     0,     0,
     513,   517,   521,     0,   522,     0,   519,   197,   528,   539,
       0,     0,     0,    18,     0,     0,     0,     0,    18,     0,
      18,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   721,   700,     0,   706,     0,     0,   644,
     645,   643,   642,   654,   657,   658,   659,   652,   651,     0,
       0,   655,   649,     0,     0,     0,     0,    18,     0,    18,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   791,   783,     0,   494,   330,   488,   392,   343,     0,
     420,     0,     0,     0,     0,     0,   366,   348,   364,   420,
     362,   420,   359,     0,     0,     0,     0,     0,   523,   524,
       0,     0,     0,     0,     0,     0,     0,     0,    18,   666,
     708,   698,     0,     0,     0,     0,     0,   693,   687,   688,
     689,    18,   699,     0,   682,   662,   665,   663,     0,   680,
       0,   667,   669,   670,   671,   672,   673,   674,   675,   676,
      18,    18,   664,     0,    18,   719,   707,   703,   653,   656,
     764,    18,    18,     0,   759,   762,   763,   781,     0,     0,
       0,   776,   784,   787,   786,   785,   782,    18,     0,   761,
     760,     0,     0,    18,   765,    18,    18,   789,   339,   420,
     378,   391,   382,     0,     0,     0,     0,     0,     0,   190,
     192,   514,   515,   516,   525,   526,     0,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   194,   683,     0,
     691,   690,   692,   163,   164,   694,   695,     0,   696,    18,
     679,   668,   678,   681,   684,   677,   780,   769,   771,   774,
     777,   775,     0,   778,   773,   770,   772,   766,   767,   768,
       0,   502,   500,   501,   499,   353,   420,   193,   197,   197,
     197,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   197,     0,     0,     0,     0,   686,   710,   709,   697,
     685,   779,     0,   204,   202,   203,   205,   197,   197,   197,
     197,   711,     0,   420,   198,   199,   200,   201,   712,     0,
     368
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1367, -1367, -1367, -1367,   -14,  -214,  -221,  -262,  -947,  -147,
    -727, -1367,  -950,   -83, -1367, -1367, -1367, -1367, -1367,  1237,
     926, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367,   489,  1433, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367,  -298, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367,  1598,   -98,  1516, -1367,   -15,  -297, -1367, -1367,
   -1367, -1367,   707,  -584,   510, -1367, -1367,   214, -1367, -1367,
   -1367, -1367,   -26, -1367,   797,   283, -1367,   800,  -943,    87,
   -1366, -1367,  -460, -1367, -1367, -1367, -1367, -1367,  -130, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,  -311,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367,   872,  1434, -1367, -1367, -1367, -1367,
    -845,   733,   574,  1242,  1072,  1448, -1367,   928, -1367, -1367,
   -1077, -1367,   328,  -185,  1023,   226, -1009, -1283,  1642, -1273,
   -1260,  1026,   234, -1367, -1367,  -180,  1022, -1367, -1367, -1367,
   -1367,  -386,   591, -1367, -1367,  -954, -1367,  -161,   661,   -17,
   -1367, -1367,   476,   813,   557,  -951, -1367, -1367, -1367, -1367,
     762,   459, -1367, -1367, -1367,   515, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367,   922, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367,   501, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367,   462, -1367, -1367, -1367, -1367, -1367,  -282, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367,   881, -1367, -1367, -1367,
   -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1367, -1128
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    89,   551,   560,   552,   390,   929,   992,
     993,   776,  1718,   205,   704,    90,   539,   206,   542,   532,
     533,    91,   214,   215,    92,    93,    20,    21,    22,    23,
      24,    25,   134,   354,    94,  1187,   337,    95,   343,   338,
      96,   571,    97,   574,   885,    98,   564,    99,   100,   582,
     101,   102,   230,   256,   598,  1084,   899,   587,   103,   894,
    1235,  1081,   895,  1334,  1335,   857,   858,  1637,   104,   105,
     591,   257,   348,   713,   714,   363,   724,   725,  1453,  1613,
    1454,  1455,  1627,  1722,    26,    27,    28,    29,   384,    30,
      31,    32,   375,   752,    33,   372,   737,    34,   376,   365,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,   198,   535,    48,    49,    50,    51,    52,
      53,    54,    55,    56,   128,   369,   106,   572,   107,   875,
     876,   877,  1076,   901,   902,   599,   888,   879,   108,   577,
    1227,  1228,  1412,   187,   436,  1493,   808,   437,   809,   438,
     439,   440,  1497,   441,  1498,   188,   443,   444,  1414,   406,
     189,   407,   416,   190,   191,   192,  1182,   193,   505,  1218,
    1183,  1301,  1302,   788,   789,  1229,   109,  1091,   907,   110,
    1241,  1391,  1456,  1526,  1390,  1337,  1242,  1244,  1340,  1395,
    1459,  1246,    57,   111,   628,   112,   113,   114,   311,   312,
     313,   970,  1150,  1270,  1275,  1273,  1274,  1401,  1470,  1151,
    1403,  1480,  1152,  1555,  1400,  1464,  1465,  1558,  1729,  1802,
    1788,  1262,  1280,  1343,  1397,  1461,  1399,  1263,  1010,    58,
      59,    60,    61,    62,    63,    64,    65,   765,   115,   116,
     117,  1159,   974,   118,  1281,  1482,  1593,  1686,  1481,  1405,
    1282,    66,    67,   119,   120,   326,   981,   982,   327,  1185,
     983,   690,    68,   121,    69,   122,   123,   124,   506
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     194,   435,   225,   561,   408,   662,   442,   896,   391,   392,
    1323,  1047,   627,   630,   300,   780,   310,   781,   318,   783,
     784,  1006,   325,  1289,   387,   339,   344,   590,   774,  1181,
    1318,  1162,  1184,   540,   814,   815,   779,  1217,  1219,  1221,
    1222,   414,  1075,  1682,   401,  1486,   617,  1430,   402,   890,
    1437,   624,  1440,  1298,  1487,  1488,  1489,  1051,   403,   388,
     389,   620,   388,   389,  1683,   135,   645,   401,   543,   226,
     228,   402,   544,   388,   389,   656,   543,   658,   543,   651,
     544,   403,   544,   663,  -326,  1564,   666,  1338,   545,   546,
     547,   548,     1,  -326,  -326,  -326,  -326,  1167,   545,   546,
     547,   548,  1638,    70,   195,   345,   360,   930,   692,   412,
     694,  1068,   791,   196,   346,   361,   370,  1181,   508,   509,
     510,   511,   512,   565,   543,   566,   567,   568,   544,  1168,
    1164,  1494,   513,   514,   515,   516,   517,   518,   519,   520,
     521,  1495,  1466,   522,   545,   546,   547,   548,   543,   543,
    1614,  -325,   544,   544,  1496,   216,   930,  1723,   417,  1724,
    -325,  -325,  -325,  -325,  1167,   378,   388,   389,   429,   897,
     603,   621,   217,   940,   142,   678,   592,   565,   549,   566,
     567,   568,   553,   616,   430,   431,   432,   169,   433,   229,
     508,   509,   510,   511,   512,   554,  1168,   622,  1169,   200,
     593,   385,   559,   559,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   218,   543,   522,  1286,   584,   544,   430,
     431,   432,  1051,   433,  1565,   543,   219,   543,   751,   544,
     609,   544,  1410,   589,   545,   546,   547,   548,   201,   202,
     408,  1639,   408,  1165,   408,   408,   569,   762,   931,   763,
     764,   386,   767,   769,   207,   771,   772,   594,   595,   626,
     430,   431,   432,  1051,   433,  1169,   596,   812,  1684,   379,
     813,   652,   880,  1065,  1181,  1633,  1634,  1330,  1170,  1171,
    1172,  1173,  1174,  1175,  1176,  1487,  1488,  1489,  1051,  1570,
     893,  1467,   665,  1487,  1488,  1489,  1051,   931,   891,   371,
    1177,   543,   543,  1178,   543,   544,   544,  1069,   544,  1377,
    1566,  1379,  1468,  1685,  1381,   941,  1384,  1386,  1494,  1339,
     555,   698,   545,   546,   547,   548,   543,  1640,  1495,   208,
     544,   629,   610,   413,  1484,   846,   792,   722,  1360,   718,
     380,  1496,  1689,   209,  1614,  1170,  1171,  1172,  1173,  1174,
    1175,  1176,   956,   543,  1234,   378,   732,   544,   556,   557,
     378,   925,   224,   911,   892,  1650,  1469,  1177,  1633,  1634,
    1178,  1556,   143,   545,   546,   547,   548,   817,  1557,   155,
     818,   766,   976,   723,   597,  1075,   768,   782,  1268,  1690,
     910,   913,   156,   787,   881,   882,   883,   541,   921,   220,
     923,   797,   798,   799,   800,   801,   775,  1290,  1181,  1597,
    1324,  1413,   221,  1366,  1325,  1048,   816,   810,   944,   222,
     978,  1507,   979,   949,  1367,   951,  1509,   955,  1510,   957,
    1319,  1512,   960,   961,   962,   404,   632,  1635,   415,   733,
     966,   405,   991,   967,  1522,  1490,   633,  1431,  1671,  1491,
    1438,  1462,  1441,   210,  1471,   843,   975,  1181,   404,   550,
    1479,   388,   389,  1523,   405,  1786,   625,   550,  1600,   550,
     932,  1601,   211,  1636,   987,   988,   989,   197,   347,   362,
     201,   202,  1011,   223,  -326,  1022,   991,  1024,  -326,  1025,
    1026,   819,   820,   821,   822,   823,   824,   825,   826,   827,
     828,   829,   830,   831,   832,   203,  1333,   575,  1042,   734,
     227,   381,  1043,  1028,   570,   550,   204,   805,  1554,  1254,
     842,   806,  1672,  1701,   735,   382,   383,  1725,   212,  1726,
    1679,  1181,  1181,   847,  1413,   559,   736,   604,  1592,   550,
     550,   848,   508,   509,   510,   511,   512,   232,   856,   707,
     543,  -325,   129,   859,   544,  -325,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   350,  1680,   522,   570,  1276,
     545,   546,   547,   548,   351,   434,   353,   125,   126,   898,
     904,   681,   592,  1524,  1525,   905,   898,   906,   898,  1214,
    1002,  1012,   355,  1215,   364,   919,   920,   213,   708,   709,
    1707,   356,  1708,   127,   918,   550,   600,  1013,   912,   543,
    1052,   710,   711,   544,   712,   933,   550,   935,   550,   349,
     938,  1073,   352,   942,   943,   359,   435,   435,   373,   545,
     546,   547,   548,  1417,  1237,   884,  1021,   442,  1023,   374,
     508,   509,   510,   511,   512,  1204,  1181,  1693,  1316,  1124,
     682,   434,  1317,   969,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   594,   595,   522,  1265,  1266,   853,   854,
     855,  1730,  1731,  1719,   366,   367,  1699,   985,  1342,   986,
     377,   683,  1085,   378,  1490,  1238,  1239,  1240,   990,   409,
     684,  1136,   550,   550,  1098,   550,  1418,  1419,  1321,  1267,
     368,  1103,  1322,  1105,  1014,   201,   202,   952,   393,   508,
     509,   510,   511,   512,   637,   638,  1192,   550,  1163,  1193,
     641,   642,  1195,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   394,  1428,   522,   953,   954,  1429,   395,  1196,
     396,  1198,  1433,  1078,   550,   397,  1434,   508,   509,   510,
     511,   512,   398,  1420,   388,   389,   977,  1792,  1139,  1421,
    1027,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     649,   650,   522,  1782,  1783,  1784,  1785,   685,   686,   687,
     688,   508,   509,   510,   511,   512,   399,  1044,   400,  1045,
     597,   672,   673,  1737,  1809,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   520,   521,   522,   410,   522,  1090,
     418,   833,   411,   508,   509,   510,   511,   512,   536,   991,
     537,  1140,   125,   126,   839,   840,  1245,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   834,   419,   522,   508,
     509,   510,   511,   512,   835,   420,  1167,   421,   127,   836,
     837,   838,  1752,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   422,   233,   522,  1015,  1072,   534,   234,   423,
     408,  1771,  1772,  1773,  1774,  1775,  1158,   538,  1168,   136,
     137,   140,   141,   558,   508,   509,   510,   511,   512,   366,
     367,   199,   576,   129,  1092,  1093,   562,  1095,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   849,   850,   522,
    1016,   573,   235,  1141,   563,  1017,  1109,  1110,   578,  1264,
    1112,  1269,  1114,  1115,    71,  1117,   579,  1277,   580,   130,
    1018,  1123,   994,   995,  1283,   754,   581,   131,   132,   133,
     583,   550,   585,  1287,   586,  1033,   588,  1169,   851,   852,
    1137,   755,  1167,   236,  1138,    72,   997,   998,  1296,  1019,
    1020,   605,  1167,   602,    73,  1061,   840,    74,  1142,  1517,
    1518,   991,   606,  1349,   138,   139,  1618,  1619,    75,   388,
     389,  1233,  1714,  1715,  1168,  1444,   607,  1445,  1720,  1721,
    1143,    76,  1144,   608,  1168,  1370,  1371,  1145,  1272,  1146,
     550,    77,   611,  1147,  1148,   794,   795,    78,   612,   613,
     357,   358,   614,   615,   618,  1446,   787,   623,   756,   619,
    1208,  1209,  1210,   631,  1211,   634,  1212,  1170,  1171,  1172,
    1173,  1174,  1175,  1176,   635,  1223,   636,    79,   639,    80,
      81,  1225,   640,  1037,   237,  1149,  1346,    82,   643,  1177,
     757,   758,  1178,  1169,   644,   647,   646,   648,   759,   653,
     654,   655,   165,  1169,   166,   167,   168,   169,   170,   171,
     508,   509,   510,   511,   512,   657,   172,   173,   807,   174,
     659,   175,    83,    84,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   760,    85,   522,   660,  1444,  1776,  1777,
    1778,  1779,  1780,  1447,  1448,   661,   664,  1449,  1450,   668,
     667,   669,  1038,  1451,   671,   670,   238,    86,   674,   675,
      87,   677,   679,   676,   680,   691,   689,  1446,   693,   695,
     697,   761,  1457,  1170,  1171,  1172,  1173,  1174,  1175,  1176,
    1472,   696,  1284,  1170,  1171,  1172,  1173,  1174,  1175,  1176,
    1039,  1288,   699,   157,   702,  1177,  1293,   700,  1178,   703,
    1294,  1295,   701,   705,   706,  1177,  1300,   715,  1178,   176,
     717,   239,  1303,   719,   720,   177,   240,   721,   726,   727,
     777,   728,   730,   731,  1041,   508,   509,   510,   511,   512,
     241,   770,   773,   778,   793,   785,  1314,  1179,  1315,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   786,   790,
     522,   802,   803,   796,   811,   158,  1213,   159,   160,   522,
    1621,   804,   841,   845,  1515,  1473,   860,   886,   889,  1492,
     887,   903,   908,   909,  1341,  1520,  1411,  1529,   178,   179,
     914,  1622,  1313,  1623,   916,  1559,   915,  1561,  1624,   917,
     924,  1344,  1345,  1463,  1347,  1463,  1393,   928,  1452,   922,
     926,   927,  1352,  1625,   934,  1353,   161,   162,   163,   164,
     936,   946,  1357,   787,  1359,   180,   181,   424,   425,   426,
     427,   937,   939,   948,   945,  1363,   947,   144,   145,   950,
     958,   959,   182,   964,   963,   183,  1373,  1474,  1475,  1476,
     184,  1477,   965,   968,   971,   146,   972,  1626,  1793,  1794,
    1795,   973,  1631,   984,   980,   996,  1676,  1642,   999,  1644,
     147,  1796,  1000,  1001,  1003,  1004,    88,  1008,  1007,   148,
    1009,   149,   150,  1029,  1030,  1031,  1034,  1804,  1805,  1806,
    1807,  1035,  1406,  -325,  1036,  1055,  1046,  1049,  1415,  1416,
    1056,  1300,  1058,  1180,  1063,  1080,  1675,  1071,  1677,  1064,
    1066,  1514,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1478,  1070,  1079,  1082,  1083,   165,  1094,   166,   167,   168,
     169,   170,   171,  1096,  1097,  1099,  1100,  1101,  1102,   172,
     173,  1104,   174,  1106,   175,  1107,  1111,  1186,   151,  1113,
    1116,  1711,  1712,  1713,  1194,  1118,  1119,  1728,  1120,   508,
     509,   510,   511,   512,  1492,  1121,  1492,  1190,  1122,  1125,
    1738,  1126,  1127,   513,   514,   515,   516,   517,   518,   519,
     520,   521,  1128,  1191,   522,   559,  1521,  1129,  1130,  1742,
    1743,  1197,  1131,  1745,  1199,  1200,  1132,  1133,  1134,  1135,
    1746,  1747,  1153,  1560,  1201,   185,  1160,  1202,  1563,  1161,
    1567,  1568,   186,  1571,  1203,  1206,  1753,  1787,  1207,  1032,
     152,  1230,  1757,  1598,  1758,  1759,  1224,  1231,  1232,  1248,
    1247,  1271,   176,  1291,  1602,  1603,  1604,  1605,   177,  1249,
    1250,   165,  1251,   166,   167,   168,   169,   170,   171,  1252,
    1279,  1253,  1255,  1256,  1257,   172,   173,  1258,   174,  1259,
     175,  1260,  1261,  1278,  1285,  1304,  1299,  1629,  1790,  1292,
    1305,  1306,  1307,  1308,  1327,  1320,  1326,  1645,  1646,  1647,
     153,  1649,  1651,  1329,  1332,  1336,  1662,  1348,  1350,  1351,
    1354,  1356,  1364,  1666,   154,  1365,  1368,  1369,  1372,  1382,
    1376,   178,   179,  1380,  1388,  1668,  1669,  1387,  1392,  1670,
    1394,  1398,  1674,   165,  1404,   166,   167,   168,   169,   170,
     171,  1423,  1408,  1396,  1694,  1424,  1442,   172,   173,  1216,
     174,  1485,   175,  1426,  1040,  1506,  1458,  1508,   180,   181,
     424,   425,   426,   427,  1427,  1511,  1505,  1432,   176,  1519,
    1599,   559,   559,   559,   177,   182,  1435,  1716,   183,  1436,
    1439,  1483,  1569,   184,  1444,  1615,  1501,  1502,  1732,  1733,
    1734,  1735,  1736,   165,  1503,   166,   167,   168,   169,   170,
     171,  1504,  1513,  1516,  1740,  1528,  1741,   172,   173,  1220,
     174,   165,   175,   166,   167,   168,   169,   170,   171,  1744,
    1527,  1562,  1572,  1594,  1595,   172,   173,  1606,   174,  1748,
     175,  1607,  1608,   243,  1749,  1750,  1751,   178,   179,  1609,
     176,  1610,  1611,  1620,  1754,  1612,   177,  1755,  1756,  1616,
    1617,   165,  1760,   166,   167,   168,   169,   170,   171,  1628,
    1641,  1630,  1632,   231,  1643,   172,   173,  1378,   174,  1648,
     175,  1660,   242,   245,   180,   181,  1661,   258,   900,   259,
    1663,   301,  1664,   314,  1673,   319,  1665,   320,  1667,  1678,
    1687,   182,  1688,  1691,   183,  1692,  1697,  1717,  1695,   184,
     176,  1696,  1709,   246,  1710,  1789,   177,   247,   248,   178,
     179,   250,   251,  1739,  1765,  1761,  1791,   252,   176,  1727,
    1762,  1763,  1764,  1766,   177,   165,  1768,   166,   167,   168,
     169,   170,   171,  1769,  1770,  1801,  1059,   601,   185,   172,
     173,  1383,   174,  1781,   175,   186,   180,   181,   844,  1797,
    1798,  1803,   716,  1799,  1800,   253,  1808,  1810,   176,  1236,
     254,  1355,  1188,   182,   177,  1681,   183,  1767,  1189,   178,
     179,   184,   729,  1226,  1331,   165,  1060,   166,   167,   168,
     169,   170,   171,  1596,   878,  1005,  1077,   178,   179,   172,
     173,  1385,   174,   753,   175,  1700,   165,   428,   166,   167,
     168,   169,   170,   171,  1053,  1702,   180,   181,  1054,  1057,
     172,   173,  1297,   174,  1422,   175,  1205,  1358,  1443,  1243,
    1389,  1108,  1402,   182,   180,   181,   183,   178,   179,  1460,
       0,   184,   176,  1166,     0,     0,     0,     0,   177,     0,
       0,   182,     0,     0,   183,     0,     0,     0,     0,   184,
       0,     0,     0,     0,   185,  -485,     0,     0,     0,     0,
       0,   186,     0,     0,   180,   181,   861,   862,   863,   864,
     865,   866,   867,   868,     0,   869,   870,   871,   872,   873,
     874,   182,   176,     0,   183,     0,     0,     0,   177,   184,
       0,     0,     0,     0,     0,     0,   508,   509,   510,   511,
     512,   178,   179,   176,     0,     0,     0,     0,     0,   177,
     513,   514,   515,   516,   517,   518,   519,   520,   521,     0,
       0,   522,     0,     0,     0,     0,   185,     0,   508,   509,
     510,   511,   512,   186,     0,     0,     0,     0,   180,   181,
       0,     0,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   178,   179,   522,     0,   182,     0,     0,   183,     0,
    -486,  -486,  -486,   184,     0,     0,     0,     0,     0,   315,
     316,     0,   178,   179,  -486,  -486,  -486,  -486,  -486,   518,
     519,   520,   521,     0,     0,   522,   185,     0,   180,   181,
       0,     0,     0,   186,     0,     0,     0,   317,     0,     0,
       0,     0,     0,  -480,   185,   182,     0,     0,   183,   180,
     181,   186,     0,   184,     0,     0,     0,     0,     0,     0,
       0,   508,   509,   510,   511,   512,   182,     0,     0,   183,
       0,     0,     0,     0,   184,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   185,     0,   522,     0,     0,     0,
       0,   186,   508,   509,   510,   511,   512,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   513,   514,   515,   516,
     517,   518,   519,   520,   521,     0,     0,   522,   508,   509,
     510,   511,   512,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   513,   514,   515,   516,   517,   518,   519,   520,
     521,     0,     0,   522,     0,     0,     0,     0,     0,     0,
       0,     0,   508,   509,   510,   511,   512,     0,   185,     0,
       0,     0,     0,     0,     0,   186,   513,   514,   515,   516,
     517,   518,   519,   520,   521,     0,     0,   522,   508,   509,
     510,   511,   512,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   513,   514,   515,   516,   517,   518,   519,   520,
     521,     0,     0,   522,     0,     0,     0,     0,   185,     0,
       0,     0,     0,     0,     0,   186,     0,     0,     0,     0,
       0,     0,     0,   508,   509,   510,   511,   512,     0,   185,
       0,     0,     0,     0,     0,     0,   186,   513,   514,   515,
     516,   517,   518,   519,   520,   521,     0,     0,   522,   508,
     509,   510,   511,   512,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   513,   514,   515,   516,   517,   518,   519,
     520,   521,     0,     0,   522,   508,   509,   510,   511,   512,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   513,
     514,   515,   516,   517,   518,   519,   520,   521,     0,     0,
     522,   508,   509,   510,   511,   512,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   513,   514,   515,   516,   517,
     518,   519,   520,   521,     0,     0,   522,   508,   509,   510,
     511,   512,     0,     0,     0,  1050,     0,     0,     0,     0,
       0,   513,   514,   515,   516,   517,   518,   519,   520,   521,
       0,     0,   522,     0,   508,   509,   510,   511,   512,     0,
       0,     0,     0,     0,     0,     0,     0,  1062,   513,   514,
     515,   516,   517,   518,   519,   520,   521,     0,     0,   522,
     508,   509,   510,   511,   512,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   513,   514,   515,   516,   517,   518,
     519,   520,   521,     0,     0,   522,   508,   509,   510,   511,
     512,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     513,   514,   515,   516,   517,   518,   519,   520,   521,     0,
       0,   522,   508,   509,   510,   511,   512,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   513,   514,   515,   516,
     517,   518,   519,   520,   521,     0,     0,   522,     0,     0,
    1067,   508,   509,   510,   511,   512,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   513,   514,   515,   516,   517,
     518,   519,   520,   521,     0,     0,   522,     0,     0,     0,
       0,  1309,     0,   508,   509,   510,   511,   512,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   513,   514,   515,
     516,   517,   518,   519,   520,   521,     0,  1310,   522,   508,
     509,   510,   511,   512,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   513,   514,   515,   516,   517,   518,   519,
     520,   521,     0,     0,   522,   508,   509,   510,   511,   512,
       0,  1311,     0,     0,     0,     0,     0,     0,   243,   513,
     514,   515,   516,   517,   518,   519,   520,   521,     0,     0,
     522,   508,   509,   510,   511,   512,     0,  1312,  1573,   243,
       0,     0,     0,     0,     0,   513,   514,   515,   516,   517,
     518,   519,   520,   521,     0,     0,   522,     0,   245,     0,
       0,     0,  1574,  1575,     0,     0,   328,   329,   330,     0,
     331,   332,     0,   333,     0,     0,     0,   334,     0,   245,
     335,     0,  1328,  1576,     0,     0,     0,     0,   246,     0,
       0,     0,   247,   248,     0,  1086,   250,   251,     0,     0,
       0,   243,   252,     0,     0,     0,     0,     0,  1374,   246,
       0,     0,     0,   247,   248,     0,     0,   250,   251,   243,
       0,   321,   738,   252,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1444,  1375,  1577,     0,   388,   389,   244,
     253,   245,     0,     0,     0,   254,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   245,
    1425,   253,  1578,  1446,   739,     0,   254,     0,     0,     0,
       0,   246,     0,     0,     0,   247,   248,     0,     0,   250,
     251,     0,     0,     0,     0,   252,  1698,     0,     0,   246,
       0,     0,     0,   247,   248,     0,   249,   250,   251,     0,
     508,   509,   510,   252,     0,   740,     0,     0,     0,     0,
       0,     0,     0,  1703,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   253,     0,   522,   243,     0,   254,     0,
       0,     0,     0,  1087,  1088,     0,   445,   741,     0,  1704,
       0,   253,   322,     0,   742,   743,   254,     0,     0,     0,
    1579,     0,     0,  1580,  1581,   744,     0,     0,     0,     0,
       0,  1582,     0,     0,   302,  1705,   245,   508,   509,   510,
     511,   512,   745,   746,   747,   748,     0,   749,   750,     0,
       0,   513,   514,   515,   516,   517,   518,   519,   520,   521,
       0,  1706,   522,     0,     0,     0,   246,     0,     0,     0,
     247,   248,     0,     0,   250,   251,     0,     0,     0,     0,
     252,     0,  1583,   446,   447,     0,     0,     0,  1361,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,     0,   253,     0,
    1407,     0,   445,   254,     0,     0,     0,     0,     0,     0,
       0,     0,  1584,     0,     0,     0,     0,   323,     0,   476,
       0,     0,   597,     0,     0,     0,  1409,     0,     0,  1585,
       0,     0,  1089,     0,  1586,  1587,     0,  1588,  1589,     0,
    1590,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1499,   336,     0,     0,  1591,     0,   477,   861,
     862,   863,   864,   865,   866,   867,   868,     0,   869,   870,
     871,   872,   873,   874,     0,     0,     0,     0,  1500,   446,
     447,     0,     0,     0,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   478,   479,   324,   480,   481,   482,   483,
     484,   485,   486,     0,     0,     0,     0,     0,     0,   507,
       0,     0,  1362,   255,   508,   509,   510,   511,   512,     0,
       0,     0,     0,     0,     0,   243,     0,     0,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   303,     0,   522,
       0,     0,   304,   305,   306,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   477,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   245,     0,     0,     0,     0,
       0,   496,   497,     0,     0,     0,   307,     0,     0,     0,
       0,     0,     0,   308,     0,     0,   498,     0,     0,   499,
     500,   501,   502,     0,     0,   246,     0,     0,     0,   247,
     248,   243,  1154,   250,   251,     0,   260,     0,     0,   252,
       0,   508,   509,   510,   511,   512,     0,     0,     0,     0,
     309,   261,     0,     0,     0,   513,   514,   515,   516,   517,
     518,   519,   520,   521,     0,   262,   522,     0,     0,  1074,
       0,   245,     0,   243,     0,     0,     0,   253,     0,     0,
       0,     0,   254,     0,     0,  1530,     0,     0,     0,   503,
     504,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   246,   340,     0,     0,   247,   248,   263,   264,   250,
     251,     0,     0,   245,     0,   252,     0,   496,   497,   265,
       0,     0,   266,     0,   267,     0,     0,     0,     0,     0,
       0,     0,   498,     0,     0,   499,   500,   501,   502,     0,
       0,     0,     0,   246,     0,     0,     0,   247,   248,     0,
       0,   250,   251,   253,     0,     0,  1444,   252,   254,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   268,     0,   269,     0,     0,     0,     0,     0,
     341,     0,     0,   270,     0,     0,  1446,     0,     0,     0,
       0,     0,     0,     0,     0,   253,     0,     0,     0,  1531,
     254,     0,     0,     0,     0,   503,   504,     0,     0,     0,
       0,     0,     0,  1532,     0,     0,     0,     0,     0,     0,
       0,   271,   861,   862,   863,   864,   865,   866,   867,   868,
       0,   869,   870,   871,   872,   873,   874,     0,     0,   272,
       0,     0,     0,     0,     0,     0,   273,   274,     0,   275,
       0,     0,     0,     0,   276,   277,     0,   278,   279,     0,
     280,     0,     0,   281,   282,   283,     0,     0,     0,     0,
       0,     0,     0,  1533,     0,  1155,  1534,  1535,   284,   285,
       0,     4,     0,   286,  1536,   287,   288,     0,   289,     0,
       0,     0,     0,   290,     0,     0,  1156,   291,   292,     0,
     293,   294,     0,   295,   296,   297,     5,     6,     0,   298,
       0,     0,     0,     0,     0,     0,     7,     0,     0,  1157,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1537,     0,     0,  1538,     0,
       0,  1539,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1540,     0,  1541,     0,  1542,  1543,  1544,  1545,
    1546,  1547,     0,     0,     0,     0,     0,  1548,     0,     8,
    1549,     0,     0,  1550,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1551,     0,     0,     0,     0,
       0,     0,     0,  1552,     0,   299,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     9,     0,     0,    10,     0,
      11,     0,     0,     0,     0,     0,     0,    12,     0,    13,
       0,     0,     0,     0,    14,    15,    16,     0,     0,  1553,
       0,    17,    18,    19,     0,     0,     0,   342
};

static const yytype_int16 yycheck[] =
{
      17,   186,    85,   217,   165,   303,   186,   591,   155,   156,
       7,     7,   274,   275,   112,   401,   114,   403,   116,   405,
     406,   748,   120,    22,   154,   123,   124,   248,    30,   983,
       7,   978,   983,    45,    27,    28,     7,  1046,  1047,  1048,
    1049,    15,   887,   127,    15,     6,   267,     7,    19,   161,
       7,   272,     7,  1181,    15,    16,    17,    18,    29,    18,
      19,   187,    18,    19,   148,     3,   287,    15,    15,    86,
      19,    19,    19,    18,    19,   296,    15,   298,    15,   122,
      19,    29,    19,   304,     6,   127,   307,    31,    35,    36,
      37,    38,     4,    15,    16,    17,    18,    19,    35,    36,
      37,    38,   127,     0,    36,    36,    36,    42,   329,    28,
     331,    19,    28,    45,    45,    45,     3,  1071,     8,     9,
      10,    11,    12,    15,    15,    17,    18,    19,    19,    51,
     254,  1414,    22,    23,    24,    25,    26,    27,    28,    29,
      30,  1414,   186,    33,    35,    36,    37,    38,    15,    15,
    1516,     6,    19,    19,  1414,    50,    42,   138,   175,   140,
      15,    16,    17,    18,    19,    19,    18,    19,   185,    36,
     253,   297,    67,   135,     3,   322,    45,    15,    69,    17,
      18,    19,   208,   266,    15,    16,    17,    18,    19,   138,
       8,     9,    10,    11,    12,   209,    51,   323,   120,    19,
      69,   144,   216,   217,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    81,    15,    33,  1163,   243,    19,    15,
      16,    17,    18,    19,   266,    15,    19,    15,   375,    19,
     180,    19,  1360,   247,    35,    36,    37,    38,    19,    20,
     401,   266,   403,   367,   405,   406,   138,   377,   183,   379,
     380,   194,   382,   383,    68,   385,   386,   126,   127,   273,
      15,    16,    17,    18,    19,   120,   135,   411,   352,   123,
     414,   314,    42,   857,  1228,   178,   179,  1228,   200,   201,
     202,   203,   204,   205,   206,    15,    16,    17,    18,   155,
     588,   335,   306,    15,    16,    17,    18,   183,   410,   186,
     222,    15,    15,   225,    15,    19,    19,   215,    19,  1318,
     352,  1320,   356,   397,  1323,   277,  1325,  1326,  1601,   263,
      20,   335,    35,    36,    37,    38,    15,   352,  1601,   143,
      19,   183,   282,   252,  1411,   549,   252,   128,  1292,   353,
     194,  1601,   343,   157,  1710,   200,   201,   202,   203,   204,
     205,   206,   649,    15,  1081,    19,     3,    19,    58,    59,
      19,   623,   143,    76,   585,   155,   410,   222,   178,   179,
     225,   356,   161,    35,    36,    37,    38,   411,   363,   161,
     414,    45,   679,   174,   253,  1230,    45,   404,   335,   390,
     611,   612,   161,   410,   164,   165,   166,   409,   619,   117,
     621,   418,   419,   420,   421,   422,   408,   406,  1362,  1486,
     407,  1362,    19,    22,   411,   411,   409,   434,   639,    86,
     682,  1430,   684,   644,    33,   646,  1435,   648,  1437,   650,
     407,  1440,   653,   654,   655,   406,   271,   340,   412,    86,
     661,   412,   704,   664,   127,   406,   281,   407,   322,   410,
     407,   410,   407,    43,   410,   538,   677,  1411,   406,   406,
    1403,    18,    19,   146,   412,   410,   405,   406,   408,   406,
     405,   411,    62,   376,   695,   696,   697,   409,   409,   409,
      19,    20,   764,   163,   406,   767,   748,   769,   410,   771,
     772,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,    44,  1233,   224,   407,   156,
      19,   365,   411,   775,   406,   406,    55,   407,  1461,   405,
     537,   411,   396,  1600,   171,   379,   380,   138,   118,   140,
     340,  1485,  1486,   550,  1485,   549,   183,   254,  1481,   406,
     406,   555,     8,     9,    10,    11,    12,   409,   562,    79,
      15,   406,    20,   570,    19,   410,    22,    23,    24,    25,
      26,    27,    28,    29,    30,     3,   376,    33,   406,   370,
      35,    36,    37,    38,     3,   406,    67,    19,    20,   593,
     597,   205,    45,   266,   267,   600,   600,   602,   602,   407,
     737,     3,     3,   411,    86,   257,   258,   187,   128,   129,
    1609,     3,  1611,    45,   618,   406,    69,    19,   321,    15,
     406,   141,   142,    19,   144,   629,   406,   631,   406,   130,
     634,   883,   133,   637,   638,     3,   811,   812,     3,    35,
      36,    37,    38,   126,    81,   405,   766,   817,   768,     3,
       8,     9,    10,    11,    12,  1031,  1600,   358,   407,   947,
     274,   406,   411,   667,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   126,   127,    33,   335,   336,    39,    40,
      41,   360,   361,  1623,    19,    20,   406,   691,  1262,   693,
     268,   305,   903,    19,   406,   132,   133,   134,   702,    30,
     314,   405,   406,   406,   915,   406,   189,   190,   407,   368,
      45,   922,   411,   924,   116,    19,    20,   277,     3,     8,
       9,    10,    11,    12,   285,   286,  1014,   406,   980,  1017,
     295,   296,  1020,    22,    23,    24,    25,    26,    27,    28,
      29,    30,     3,   407,    33,   305,   306,   411,     3,  1021,
       3,  1023,   407,   890,   406,     3,   411,     8,     9,    10,
      11,    12,     3,   246,    18,    19,    20,  1766,   123,   252,
     774,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      86,    87,    33,  1723,  1724,  1725,  1726,   401,   402,   403,
     404,     8,     9,    10,    11,    12,     3,   804,     3,   806,
     253,   384,   385,   258,  1803,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    29,    30,    33,   406,    33,   907,
     406,   209,   252,     8,     9,    10,    11,    12,     3,  1081,
      22,   186,    19,    20,   410,   411,  1088,    22,    23,    24,
      25,    26,    27,    28,    29,    30,   234,   406,    33,     8,
       9,    10,    11,    12,   242,   406,    19,   406,    45,   247,
     248,   249,   258,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   406,    73,    33,   277,   880,    15,    78,   406,
    1031,   148,   149,   150,   151,   152,   974,    63,    51,     7,
       8,     9,    10,   405,     8,     9,    10,    11,    12,    19,
      20,    19,   405,    20,   908,   909,   180,   911,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    60,    61,    33,
     322,    19,   122,   278,   169,   327,   930,   931,   138,  1140,
     934,  1142,   936,   937,     3,   939,    19,  1148,   409,    56,
     342,   945,   410,   411,  1155,     3,   409,    64,    65,    66,
     409,   406,   322,  1164,    19,   411,   117,   120,    60,    61,
     964,    19,    19,   163,   968,    34,   410,   411,  1179,   371,
     372,   405,    19,    69,    43,   410,   411,    46,   333,   257,
     258,  1233,   405,  1271,   171,   172,   148,   149,    57,    18,
      19,    20,   148,   149,    51,   137,   409,   139,   146,   147,
     355,    70,   357,   409,    51,  1306,  1307,   362,  1145,   364,
     406,    80,   322,   368,   369,   414,   415,    86,    81,   405,
     138,   139,    20,   283,    69,   167,  1033,   166,    86,    85,
    1037,  1038,  1039,    76,  1041,    76,  1043,   200,   201,   202,
     203,   204,   205,   206,   269,  1052,   276,   116,    87,   118,
     119,  1058,   281,   411,   254,   410,  1267,   126,   295,   222,
     118,   119,   225,   120,   299,   304,   302,   309,   126,    87,
     317,   315,    13,   120,    15,    16,    17,    18,    19,    20,
       8,     9,    10,    11,    12,   264,    27,    28,    29,    30,
     405,    32,   161,   162,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   161,   173,    33,   409,   137,   148,   149,
     150,   151,   152,   255,   256,   364,   116,   259,   260,   405,
     117,   409,   411,   265,    86,   409,   326,   196,   405,   409,
     199,   322,    86,   409,   405,    86,   409,   167,    76,    79,
      85,   199,  1394,   200,   201,   202,   203,   204,   205,   206,
     180,    81,  1156,   200,   201,   202,   203,   204,   205,   206,
     411,  1165,   405,    79,    76,   222,  1173,   405,   225,    20,
    1177,  1178,   405,   405,   405,   222,  1183,     3,   225,   120,
       3,   381,  1186,     3,     3,   126,   386,     3,     3,    19,
     181,     3,     3,     3,   411,     8,     9,    10,    11,    12,
     400,     3,     3,   181,    28,    14,  1213,   254,  1215,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    15,    27,
      33,    19,    15,    30,     7,   141,   411,   143,   144,    33,
     117,   411,     3,   405,  1445,   265,   405,   405,    19,  1414,
     406,   136,    76,    76,  1248,  1449,   409,  1458,   189,   190,
     405,   138,   411,   140,   405,  1466,    51,  1468,   145,   405,
     174,  1265,  1266,  1400,  1268,  1402,  1339,    31,   410,   307,
     405,   405,  1276,   160,   183,  1279,   192,   193,   194,   195,
      76,   405,  1289,  1290,  1291,   226,   227,   228,   229,   230,
     231,    76,    76,   405,    76,   409,   117,   143,   144,   405,
     405,   405,   243,   183,   405,   246,  1313,   337,   338,   339,
     251,   341,   405,    69,    19,   161,   405,   204,  1768,  1769,
    1770,   405,  1533,   405,   274,     3,  1578,  1538,     3,  1540,
     176,  1781,    19,    15,    19,    19,   405,     3,    19,   185,
      20,   187,   188,    15,    15,    15,   407,  1797,  1798,  1799,
    1800,   252,  1356,   410,    28,    15,   411,   411,  1365,  1366,
      18,  1368,   406,   410,    20,    28,  1577,   409,  1579,   405,
     405,  1444,   343,   344,   345,   346,   347,   348,   349,   350,
     410,   405,   405,   411,   131,    13,   405,    15,    16,    17,
      18,    19,    20,   405,   405,   405,   405,   405,   405,    27,
      28,   405,    30,   405,    32,    19,   405,    69,   254,   405,
     405,  1615,  1616,  1617,    15,   405,   405,  1628,   405,     8,
       9,    10,    11,    12,  1599,   405,  1601,     3,   405,   405,
    1641,   405,   405,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   405,     3,    33,  1449,  1450,   405,   405,  1660,
    1661,     3,   405,  1664,     3,     3,   405,   405,   405,   405,
    1671,  1672,   405,  1467,     3,   406,   405,   183,  1472,   405,
    1474,  1475,   413,  1477,   183,    28,  1687,  1729,    28,   407,
     326,   405,  1693,  1490,  1695,  1696,   411,   407,   181,   411,
     405,   322,   120,    22,  1501,  1502,  1503,  1504,   126,   405,
     405,    13,   405,    15,    16,    17,    18,    19,    20,   405,
     373,   405,   405,   405,   405,    27,    28,   405,    30,   405,
      32,   405,   405,   405,   405,     3,   405,  1531,  1739,   406,
       3,    15,    15,    28,    15,   411,   411,  1541,  1542,  1543,
     386,  1545,  1546,   410,    15,   409,  1550,   409,   409,   409,
     409,    69,   405,  1557,   400,    22,   411,   405,    28,     7,
      29,   189,   190,    29,   183,  1569,  1570,   410,    19,  1573,
     264,   409,  1576,    13,   409,    15,    16,    17,    18,    19,
      20,     3,   407,   405,  1588,     3,    15,    27,    28,    29,
      30,   224,    32,   407,   407,    29,   261,    29,   226,   227,
     228,   229,   230,   231,   407,     7,   405,   407,   120,   258,
       7,  1615,  1616,  1617,   126,   243,   406,  1621,   246,   407,
     407,   407,   281,   251,   137,   259,   406,   406,  1632,  1633,
    1634,  1635,  1636,    13,   406,    15,    16,    17,    18,    19,
      20,   406,   405,   409,  1648,   405,  1650,    27,    28,    29,
      30,    13,    32,    15,    16,    17,    18,    19,    20,  1663,
     409,   405,   405,   405,   410,    27,    28,   407,    30,  1673,
      32,   407,   407,    46,  1678,  1679,  1680,   189,   190,   411,
     120,   407,   406,   146,  1688,   407,   126,  1691,  1692,   259,
     259,    13,  1699,    15,    16,    17,    18,    19,    20,   322,
     317,   409,   359,    95,   377,    27,    28,    29,    30,   281,
      32,   375,   104,    86,   226,   227,   345,   109,    19,   111,
     367,   113,   343,   115,    76,   117,   405,   119,   405,   359,
     317,   243,   367,    76,   246,    76,   405,    20,   393,   251,
     120,   395,   410,   116,   405,   358,   126,   120,   121,   189,
     190,   124,   125,   378,   407,   405,   358,   130,   120,   410,
     405,   405,   405,   411,   126,    13,   405,    15,    16,    17,
      18,    19,    20,   405,   405,   353,   840,   251,   406,    27,
      28,    29,    30,   405,    32,   413,   226,   227,   541,   405,
     405,   411,   349,   405,   405,   168,   405,   407,   120,  1082,
     173,  1281,   995,   243,   126,  1581,   246,  1710,   998,   189,
     190,   251,   368,  1070,  1230,    13,   405,    15,    16,    17,
      18,    19,    20,  1485,   572,   743,   888,   189,   190,    27,
      28,    29,    30,   375,    32,  1599,    13,   185,    15,    16,
      17,    18,    19,    20,   811,  1601,   226,   227,   812,   817,
      27,    28,  1181,    30,  1368,    32,  1033,  1290,  1389,  1087,
    1335,   929,  1351,   243,   226,   227,   246,   189,   190,  1397,
      -1,   251,   120,   982,    -1,    -1,    -1,    -1,   126,    -1,
      -1,   243,    -1,    -1,   246,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,   406,   407,    -1,    -1,    -1,    -1,
      -1,   413,    -1,    -1,   226,   227,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   216,   217,   218,   219,   220,
     221,   243,   120,    -1,   246,    -1,    -1,    -1,   126,   251,
      -1,    -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,
      12,   189,   190,   120,    -1,    -1,    -1,    -1,    -1,   126,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,    -1,    -1,    -1,    -1,   406,    -1,     8,     9,
      10,    11,    12,   413,    -1,    -1,    -1,    -1,   226,   227,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,   189,   190,    33,    -1,   243,    -1,    -1,   246,    -1,
       8,     9,    10,   251,    -1,    -1,    -1,    -1,    -1,   382,
     383,    -1,   189,   190,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,   406,    -1,   226,   227,
      -1,    -1,    -1,   413,    -1,    -1,    -1,   410,    -1,    -1,
      -1,    -1,    -1,   405,   406,   243,    -1,    -1,   246,   226,
     227,   413,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,     9,    10,    11,    12,   243,    -1,    -1,   246,
      -1,    -1,    -1,    -1,   251,    22,    23,    24,    25,    26,
      27,    28,    29,    30,   406,    -1,    33,    -1,    -1,    -1,
      -1,   413,     8,     9,    10,    11,    12,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,     9,    10,    11,    12,    -1,   406,    -1,
      -1,    -1,    -1,    -1,    -1,   413,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,    -1,    -1,    -1,    -1,   406,    -1,
      -1,    -1,    -1,    -1,    -1,   413,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,   406,
      -1,    -1,    -1,    -1,    -1,    -1,   413,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,     8,     9,    10,
      11,    12,    -1,    -1,    -1,   407,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,
     407,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,    -1,
      -1,   407,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,   407,    33,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,     8,     9,    10,    11,    12,
      -1,   407,    -1,    -1,    -1,    -1,    -1,    -1,    46,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,     8,     9,    10,    11,    12,    -1,   407,    42,    46,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,    -1,    86,    -1,
      -1,    -1,    66,    67,    -1,    -1,    73,    74,    75,    -1,
      77,    78,    -1,    80,    -1,    -1,    -1,    84,    -1,    86,
      87,    -1,   407,    87,    -1,    -1,    -1,    -1,   116,    -1,
      -1,    -1,   120,   121,    -1,   123,   124,   125,    -1,    -1,
      -1,    46,   130,    -1,    -1,    -1,    -1,    -1,   407,   116,
      -1,    -1,    -1,   120,   121,    -1,    -1,   124,   125,    46,
      -1,    66,     3,   130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   137,   407,   139,    -1,    18,    19,    66,
     168,    86,    -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,
     407,   168,   166,   167,    45,    -1,   173,    -1,    -1,    -1,
      -1,   116,    -1,    -1,    -1,   120,   121,    -1,    -1,   124,
     125,    -1,    -1,    -1,    -1,   130,   407,    -1,    -1,   116,
      -1,    -1,    -1,   120,   121,    -1,   123,   124,   125,    -1,
       8,     9,    10,   130,    -1,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   407,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   168,    -1,    33,    46,    -1,   173,    -1,
      -1,    -1,    -1,   261,   262,    -1,     5,   118,    -1,   407,
      -1,   168,   187,    -1,   125,   126,   173,    -1,    -1,    -1,
     254,    -1,    -1,   257,   258,   136,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    84,   407,    86,     8,     9,    10,
      11,    12,   153,   154,   155,   156,    -1,   158,   159,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,   407,    33,    -1,    -1,    -1,   116,    -1,    -1,    -1,
     120,   121,    -1,    -1,   124,   125,    -1,    -1,    -1,    -1,
     130,    -1,   316,    82,    83,    -1,    -1,    -1,   405,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,    -1,   168,    -1,
     405,    -1,     5,   173,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   366,    -1,    -1,    -1,    -1,   312,    -1,   138,
      -1,    -1,   253,    -1,    -1,    -1,   405,    -1,    -1,   383,
      -1,    -1,   410,    -1,   388,   389,    -1,   391,   392,    -1,
     394,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   405,   410,    -1,    -1,   410,    -1,   177,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,   216,   217,
     218,   219,   220,   221,    -1,    -1,    -1,    -1,   405,    82,
      83,    -1,    -1,    -1,    -1,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   232,   233,   410,   235,   236,   237,   238,
     239,   240,   241,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,   223,   410,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   327,    -1,    33,
      -1,    -1,   332,   333,   334,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,
      -1,   310,   311,    -1,    -1,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,   373,    -1,    -1,   325,    -1,    -1,   328,
     329,   330,   331,    -1,    -1,   116,    -1,    -1,    -1,   120,
     121,    46,   123,   124,   125,    -1,    51,    -1,    -1,   130,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
     410,    66,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    80,    33,    -1,    -1,   407,
      -1,    86,    -1,    46,    -1,    -1,    -1,   168,    -1,    -1,
      -1,    -1,   173,    -1,    -1,    66,    -1,    -1,    -1,   398,
     399,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   116,    75,    -1,    -1,   120,   121,   122,   123,   124,
     125,    -1,    -1,    86,    -1,   130,    -1,   310,   311,   134,
      -1,    -1,   137,    -1,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   325,    -1,    -1,   328,   329,   330,   331,    -1,
      -1,    -1,    -1,   116,    -1,    -1,    -1,   120,   121,    -1,
      -1,   124,   125,   168,    -1,    -1,   137,   130,   173,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   187,    -1,   189,    -1,    -1,    -1,    -1,    -1,
     153,    -1,    -1,   198,    -1,    -1,   167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   180,
     173,    -1,    -1,    -1,    -1,   398,   399,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   236,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,   218,   219,   220,   221,    -1,    -1,   254,
      -1,    -1,    -1,    -1,    -1,    -1,   261,   262,    -1,   264,
      -1,    -1,    -1,    -1,   269,   270,    -1,   272,   273,    -1,
     275,    -1,    -1,   278,   279,   280,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   254,    -1,   366,   257,   258,   293,   294,
      -1,    46,    -1,   298,   265,   300,   301,    -1,   303,    -1,
      -1,    -1,    -1,   308,    -1,    -1,   387,   312,   313,    -1,
     315,   316,    -1,   318,   319,   320,    71,    72,    -1,   324,
      -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,   410,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   316,    -1,    -1,   319,    -1,
      -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   333,    -1,   335,    -1,   337,   338,   339,   340,
     341,   342,    -1,    -1,    -1,    -1,    -1,   348,    -1,   134,
     351,    -1,    -1,   354,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   374,    -1,   410,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,
     175,    -1,    -1,    -1,    -1,    -1,    -1,   182,    -1,   184,
      -1,    -1,    -1,    -1,   189,   190,   191,    -1,    -1,   410,
      -1,   196,   197,   198,    -1,    -1,    -1,   410
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   416,   417,    46,    71,    72,    81,   134,   170,
     173,   175,   182,   184,   189,   190,   191,   196,   197,   198,
     441,   442,   443,   444,   445,   446,   499,   500,   501,   502,
     504,   505,   506,   509,   512,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   607,   644,   645,
     646,   647,   648,   649,   650,   651,   666,   667,   677,   679,
       0,     3,    34,    43,    46,    57,    70,    80,    86,   116,
     118,   119,   126,   161,   162,   173,   196,   199,   405,   418,
     430,   436,   439,   440,   449,   452,   455,   457,   460,   462,
     463,   465,   466,   473,   483,   484,   541,   543,   553,   591,
     594,   608,   610,   611,   612,   653,   654,   655,   658,   668,
     669,   678,   680,   681,   682,    19,    20,    45,   539,    20,
      56,    64,    65,    66,   447,     3,   539,   539,   171,   172,
     539,   539,     3,   161,   143,   144,   161,   176,   185,   187,
     188,   254,   326,   386,   400,   161,   161,    79,   141,   143,
     144,   192,   193,   194,   195,    13,    15,    16,    17,    18,
      19,    20,    27,    28,    30,    32,   120,   126,   189,   190,
     226,   227,   243,   246,   251,   406,   413,   558,   570,   575,
     578,   579,   580,   582,   584,    36,    45,   409,   528,   539,
      19,    19,    20,    44,    55,   428,   432,    68,   143,   157,
      43,    62,   118,   187,   437,   438,    50,    67,    81,    19,
     117,    19,    86,   163,   143,   428,   584,    19,    19,   138,
     467,   467,   409,    73,    78,   122,   163,   254,   326,   381,
     386,   400,   467,    46,    66,    86,   116,   120,   121,   123,
     124,   125,   130,   168,   173,   410,   468,   486,   467,   467,
      51,    66,    80,   122,   123,   134,   137,   139,   187,   189,
     198,   236,   254,   261,   262,   264,   269,   270,   272,   273,
     275,   278,   279,   280,   293,   294,   298,   300,   301,   303,
     308,   312,   313,   315,   316,   318,   319,   320,   324,   410,
     468,   467,    84,   327,   332,   333,   334,   366,   373,   410,
     468,   613,   614,   615,   467,   382,   383,   410,   468,   467,
     467,    66,   187,   312,   410,   468,   670,   673,    73,    74,
      75,    77,    78,    80,    84,    87,   410,   451,   454,   468,
      75,   153,   410,   453,   468,    36,    45,   409,   487,   447,
       3,     3,   447,    67,   448,     3,     3,   539,   539,     3,
      36,    45,   409,   490,    86,   514,    19,    20,    45,   540,
       3,   186,   510,     3,     3,   507,   513,   268,    19,   123,
     194,   365,   379,   380,   503,   144,   194,   503,    18,    19,
     422,   424,   424,     3,     3,     3,     3,     3,     3,     3,
       3,    15,    19,    29,   406,   412,   574,   576,   582,    30,
     406,   252,    28,   252,    15,   412,   577,   584,   406,   406,
     406,   406,   406,   406,   228,   229,   230,   231,   563,   584,
      15,    16,    17,    19,   406,   558,   559,   562,   564,   565,
     566,   568,   570,   571,   572,     5,    82,    83,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   138,   177,   232,   233,
     235,   236,   237,   238,   239,   240,   241,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   310,   311,   325,   328,
     329,   330,   331,   398,   399,   583,   683,     3,     8,     9,
      10,    11,    12,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    33,    46,    47,    48,    49,    50,    51,    52,
      53,    54,   434,   435,    15,   529,     3,    22,    63,   431,
      45,   409,   433,    15,    19,    35,    36,    37,    38,    69,
     406,   419,   421,   487,   419,    20,    58,    59,   405,   419,
     420,   420,   180,   169,   461,    15,    17,    18,    19,   138,
     406,   456,   542,    19,   458,   490,   405,   554,   138,    19,
     409,   409,   464,   409,   487,   322,    19,   472,   117,   419,
     421,   485,    45,    69,   126,   127,   135,   253,   469,   550,
      69,   469,    69,   428,   490,   405,   405,   409,   409,   180,
     282,   322,    81,   405,    20,   283,   428,   421,    69,    85,
     187,   297,   323,   166,   421,   405,   419,   422,   609,   183,
     422,    76,   271,   281,    76,   269,   276,   285,   286,    87,
     281,   295,   296,   295,   299,   421,   302,   304,   309,    86,
      87,   122,   314,    87,   317,   315,   421,   264,   421,   405,
     409,   364,   456,   421,   116,   419,   421,   117,   405,   409,
     409,    86,   384,   385,   405,   409,   409,   322,   424,    86,
     405,   205,   274,   305,   314,   401,   402,   403,   404,   409,
     676,    86,   421,    76,   421,    79,    81,    85,   419,   405,
     405,   405,    76,    20,   429,   405,   405,    79,   128,   129,
     141,   142,   144,   488,   489,     3,   448,     3,   419,     3,
       3,     3,   128,   174,   491,   492,     3,    19,     3,   540,
       3,     3,     3,    86,   156,   171,   183,   511,     3,    45,
      86,   118,   125,   126,   136,   153,   154,   155,   156,   158,
     159,   424,   508,   550,     3,    19,    86,   118,   119,   126,
     161,   199,   503,   503,   503,   652,    45,   503,    45,   503,
       3,   503,   503,     3,    30,   408,   426,   181,   181,     7,
     576,   576,   584,   576,   576,    14,    15,   584,   588,   589,
      27,    28,   252,    28,   577,   577,    30,   584,   584,   584,
     584,   584,    19,    15,   411,   407,   411,    29,   561,   563,
     584,     7,   411,   414,    27,    28,   409,   411,   414,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   209,   234,   242,   247,   248,   249,   410,
     411,     3,   584,   428,   434,   405,   420,   584,   419,    60,
      61,    60,    61,    39,    40,    41,   419,   480,   481,   584,
     405,   207,   208,   209,   210,   211,   212,   213,   214,   216,
     217,   218,   219,   220,   221,   544,   545,   546,   548,   552,
      42,   164,   165,   166,   405,   459,   405,   406,   551,    19,
     161,   410,   421,   456,   474,   477,   478,    36,   419,   471,
      19,   548,   549,   136,   584,   471,   471,   593,    76,    76,
     421,    76,   321,   421,   405,    51,   405,   405,   419,   257,
     258,   421,   307,   421,   174,   422,   405,   405,    31,   423,
      42,   183,   405,   419,   183,   419,    76,    76,   419,    76,
     135,   277,   419,   419,   421,    76,   405,   117,   405,   421,
     405,   421,   277,   305,   306,   421,   472,   421,   405,   405,
     421,   421,   421,   405,   183,   405,   421,   421,    69,   419,
     616,    19,   405,   405,   657,   421,   472,    20,   422,   422,
     274,   671,   672,   675,   405,   419,   419,   421,   421,   421,
     419,   422,   424,   425,   410,   411,     3,   410,   411,     3,
      19,    15,   424,    19,    19,   549,   425,    19,     3,    20,
     643,   643,     3,    19,   116,   277,   322,   327,   342,   371,
     372,   503,   643,   503,   643,   643,   643,   419,   422,    15,
      15,    15,   407,   411,   407,   252,    28,   411,   411,   411,
     407,   411,   407,   411,   584,   584,   411,     7,   411,   411,
     407,    18,   406,   559,   566,    15,    18,   571,   406,   435,
     405,   410,   407,    20,   405,   478,   405,   407,    19,   215,
     405,   409,   419,   422,   407,   545,   547,   552,   424,   405,
      28,   476,   411,   131,   470,   421,   123,   261,   262,   410,
     468,   592,   419,   419,   405,   419,   405,   405,   421,   405,
     405,   405,   405,   421,   405,   421,   405,    19,   609,   419,
     419,   405,   419,   405,   419,   419,   405,   419,   405,   405,
     405,   405,   405,   419,   456,   405,   405,   405,   405,   405,
     405,   405,   405,   405,   405,   405,   405,   419,   419,   123,
     186,   278,   333,   355,   357,   362,   364,   368,   369,   410,
     617,   624,   627,   405,   123,   366,   387,   410,   468,   656,
     405,   405,   423,   422,   254,   367,   671,    19,    51,   120,
     200,   201,   202,   203,   204,   205,   206,   222,   225,   254,
     410,   580,   581,   585,   590,   674,    69,   450,   489,   492,
       3,     3,   456,   456,    15,   456,   643,     3,   643,     3,
       3,     3,   183,   183,   576,   588,    28,    28,   584,   584,
     584,   584,   584,   411,   407,   411,    29,   561,   584,   561,
      29,   561,   561,   584,   411,   584,   546,   555,   556,   590,
     405,   407,   181,    20,   425,   475,   477,    81,   132,   133,
     134,   595,   601,   595,   602,   422,   606,   405,   411,   405,
     405,   405,   405,   405,   405,   405,   405,   405,   405,   405,
     405,   405,   636,   642,   421,   335,   336,   368,   335,   421,
     618,   322,   424,   620,   621,   619,   370,   421,   405,   373,
     637,   659,   665,   421,   419,   405,   423,   421,   419,    22,
     406,    22,   406,   584,   584,   584,   421,   583,   683,   405,
     584,   586,   587,   419,     3,     3,    15,    15,    28,   407,
     407,   407,   407,   411,   584,   584,   407,   411,     7,   407,
     411,   407,   411,     7,   407,   411,   411,    15,   407,   410,
     590,   547,    15,   425,   478,   479,   409,   600,    31,   263,
     603,   419,   478,   638,   419,   419,   421,   419,   409,   456,
     409,   409,   419,   419,   409,   479,    69,   584,   589,   584,
     580,   405,   223,   409,   405,    22,    22,    33,   411,   405,
     514,   514,    28,   584,   407,   407,    29,   561,    29,   561,
      29,   561,     7,    29,   561,    29,   561,   410,   183,   600,
     599,   596,    19,   428,   264,   604,   405,   639,   409,   641,
     629,   622,   629,   625,   409,   664,   419,   405,   407,   405,
     683,   409,   557,   590,   573,   584,   584,   126,   189,   190,
     246,   252,   587,     3,     3,   407,   407,   407,   407,   411,
       7,   407,   407,   407,   411,   406,   407,     7,   407,   407,
       7,   407,    15,   596,   137,   139,   167,   255,   256,   259,
     260,   265,   410,   493,   495,   496,   597,   422,   261,   605,
     637,   640,   410,   424,   630,   631,   186,   335,   356,   410,
     623,   410,   180,   265,   337,   338,   339,   341,   410,   493,
     626,   663,   660,   407,   555,   224,     6,    15,    16,    17,
     406,   410,   558,   560,   562,   564,   565,   567,   569,   405,
     405,   406,   406,   406,   406,   405,    29,   561,    29,   561,
     561,     7,   561,   405,   428,   421,   409,   257,   258,   258,
     420,   419,   127,   146,   266,   267,   598,   409,   405,   421,
      66,   180,   194,   254,   257,   258,   265,   316,   319,   322,
     333,   335,   337,   338,   339,   340,   341,   342,   348,   351,
     354,   366,   374,   410,   493,   628,   356,   363,   632,   421,
     419,   421,   405,   419,   127,   266,   352,   419,   419,   281,
     155,   419,   405,    42,    66,    67,    87,   139,   166,   254,
     257,   258,   265,   316,   366,   383,   388,   389,   391,   392,
     394,   410,   493,   661,   405,   410,   557,   555,   584,     7,
     408,   411,   584,   584,   584,   584,   407,   407,   407,   411,
     407,   406,   407,   494,   495,   259,   259,   259,   148,   149,
     146,   117,   138,   140,   145,   160,   204,   497,   322,   419,
     409,   421,   359,   178,   179,   340,   376,   482,   127,   266,
     352,   317,   421,   377,   421,   419,   419,   419,   281,   419,
     155,   419,   343,   344,   345,   346,   347,   348,   349,   350,
     375,   345,   419,   367,   343,   405,   419,   405,   419,   419,
     419,   322,   396,    76,   419,   421,   422,   421,   359,   340,
     376,   482,   127,   148,   352,   397,   662,   317,   367,   343,
     390,    76,    76,   358,   419,   393,   395,   405,   407,   406,
     560,   555,   567,   407,   407,   407,   407,   561,   561,   410,
     405,   420,   420,   420,   148,   149,   419,    20,   427,   427,
     146,   147,   498,   138,   140,   138,   140,   410,   421,   633,
     360,   361,   419,   419,   419,   419,   419,   258,   421,   378,
     419,   419,   421,   421,   419,   421,   421,   421,   419,   419,
     419,   419,   258,   421,   419,   419,   419,   421,   421,   421,
     584,   405,   405,   405,   405,   407,   411,   494,   405,   405,
     405,   148,   149,   150,   151,   152,   148,   149,   150,   151,
     152,   405,   427,   427,   427,   427,   410,   422,   635,   358,
     421,   358,   561,   497,   497,   497,   497,   405,   405,   405,
     405,   353,   634,   411,   497,   497,   497,   497,   405,   561,
     407
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   415,   416,   416,   417,   417,   418,   419,   419,   419,
     420,   420,   420,   421,   421,   421,   421,   421,   421,   422,
     422,   423,   423,   424,   425,   425,   426,   426,   427,   428,
     428,   429,   429,   430,   431,   431,   432,   432,   432,   433,
     433,   434,   434,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   436,   436,   437,   437,   437,   437,   438,   438,
     438,   438,   438,   438,   439,   440,   440,   440,   440,   441,
     442,   443,   444,   445,   446,   447,   447,   448,   448,   448,
     449,   450,   450,   451,   451,   451,   451,   451,   451,   452,
     453,   453,   454,   454,   455,   455,   456,   456,   456,   456,
     456,   457,   458,   458,   459,   459,   459,   459,   460,   461,
     461,   462,   463,   464,   464,   465,   465,   466,   466,   467,
     467,   467,   467,   468,   468,   468,   468,   468,   468,   468,
     468,   468,   468,   468,   468,   468,   468,   469,   469,   469,
     469,   470,   470,   470,   470,   470,   471,   471,   472,   473,
     473,   474,   475,   475,   475,   476,   476,   477,   478,   478,
     479,   480,   481,   482,   482,   483,   484,   484,   484,   484,
     485,   486,   487,   487,   487,   488,   488,   489,   489,   489,
     489,   489,   489,   490,   490,   490,   491,   491,   492,   492,
     493,   493,   494,   494,   495,   495,   496,   497,   497,   497,
     497,   497,   497,   497,   497,   497,   498,   498,   498,   498,
     498,   498,   498,   498,   498,   498,   499,   500,   501,   502,
     503,   503,   504,   505,   506,   507,   507,   507,   507,   507,
     507,   507,   507,   507,   507,   507,   507,   507,   508,   508,
     508,   509,   510,   510,   510,   510,   511,   511,   511,   512,
     513,   513,   513,   513,   513,   513,   513,   513,   514,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   528,   528,   529,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   539,   539,
     540,   540,   540,   542,   541,   543,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   545,   546,   546,   547,   547,   548,   549,   549,   550,
     551,   551,   552,   554,   553,   555,   555,   556,   556,   557,
     557,   558,   559,   559,   559,   559,   559,   559,   560,   560,
     560,   560,   560,   561,   562,   562,   562,   562,   562,   562,
     562,   562,   562,   562,   563,   563,   563,   563,   564,   564,
     564,   565,   565,   565,   565,   565,   565,   565,   565,   566,
     566,   566,   566,   566,   567,   567,   567,   567,   567,   568,
     568,   569,   569,   570,   571,   571,   571,   571,   572,   572,
     573,   573,   573,   574,   574,   575,   575,   576,   576,   576,
     576,   576,   576,   577,   577,   577,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   578,   578,   579,   579,   579,
     580,   581,   582,   583,   583,   583,   583,   583,   583,   583,
     583,   583,   583,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   585,   585,   585,   585,   585,   585,   586,
     587,   587,   587,   588,   588,   589,   589,   590,   590,   590,
     590,   590,   590,   590,   590,   590,   590,   590,   590,   590,
     590,   590,   590,   591,   592,   592,   592,   592,   593,   593,
     594,   595,   596,   597,   597,   597,   597,   597,   597,   597,
     597,   598,   598,   598,   598,   598,   598,   599,   599,   600,
     600,   601,   602,   603,   603,   603,   604,   604,   605,   605,
     606,   607,   608,   609,   609,   609,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   611,   612,   612,   613,
     613,   613,   613,   613,   613,   613,   613,   613,   614,   615,
     616,   616,   617,   617,   617,   617,   617,   617,   617,   617,
     617,   618,   617,   619,   617,   617,   617,   617,   620,   620,
     621,   622,   622,   623,   623,   623,   624,   624,   625,   625,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   627,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   629,   629,   630,   631,   632,   632,   632,   633,   633,
     634,   634,   635,   636,   637,   637,   639,   638,   640,   640,
     641,   641,   642,   643,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   652,   652,   652,   652,   652,   652,
     652,   652,   653,   654,   654,   654,   654,   654,   655,   656,
     656,   656,   656,   656,   657,   657,   658,   659,   660,   661,
     661,   661,   661,   661,   661,   661,   661,   661,   661,   661,
     661,   661,   661,   661,   661,   661,   661,   661,   661,   661,
     661,   661,   661,   661,   662,   662,   662,   662,   663,   663,
     664,   664,   665,   666,   667,   668,   669,   669,   669,   669,
     669,   670,   671,   671,   671,   672,   672,   673,   673,   673,
     673,   673,   673,   673,   673,   673,   674,   674,   675,   675,
     676,   676,   677,   678,   678,   678,   678,   678,   678,   678,
     678,   678,   678,   678,   678,   678,   678,   678,   678,   679,
     679,   679,   679,   679,   679,   679,   679,   679,   679,   679,
     679,   679,   679,   679,   679,   679,   679,   679,   679,   679,
     679,   679,   679,   679,   679,   679,   679,   679,   679,   679,
     679,   679,   679,   679,   679,   679,   679,   679,   679,   679,
     679,   679,   679,   679,   679,   679,   679,   679,   680,   680,
     680,   680,   680,   680,   680,   680,   680,   681,   681,   681,
     681,   682,   682,   682,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   683
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     4,     2,     0,     1,     2,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     1,     1,     1,     1,     2,     4,
       3,     3,     3,     3,     3,     3,     4,     3,     3,     4,
       5,     3,     3,     4,     2,     0,     1,     0,     1,     2,
       2,     0,     2,     2,     3,     2,     3,     3,     4,     2,
       3,     3,     3,     2,     4,     5,     1,     3,     1,     1,
       1,     4,     0,     2,     2,     2,     1,     1,     5,     0,
       1,     3,     3,     0,     8,     1,     4,     1,     1,     0,
       1,     2,     3,     0,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     4,     2,     3,     2,     2,     1,     1,
       1,     0,     2,     2,     2,     2,     2,     1,     1,     3,
       3,     0,     1,     1,     2,     0,     1,     3,     1,     3,
       1,     0,     2,     2,     2,     2,     3,     3,     3,     5,
       0,     3,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     1,     1,
       4,     1,     0,     3,     4,     1,     2,     0,     5,     5,
       5,     5,     4,     4,     4,     4,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     4,     5,
       1,     0,     3,     4,     4,     0,     2,     3,     3,     3,
       2,     2,     2,     2,     3,     3,     2,     2,     1,     1,
       1,     4,     0,     3,     3,     3,     0,     1,     1,     4,
       0,     2,     2,     2,     2,     2,     2,     2,     0,     2,
       9,     9,     4,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     4,     1,     1,     3,     0,     1,     3,     3,
       3,     3,     4,     4,     4,     4,     2,     1,     1,     1,
       1,     0,     1,     0,     4,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     0,     3,     1,     3,     1,     1,     1,     2,
       3,     2,     4,     0,     5,     0,     1,     1,     2,     1,
       3,     1,     1,     1,     1,     1,     3,     1,     1,     3,
       1,     1,     1,     1,     5,     7,     5,     7,     9,     7,
       5,     7,     5,    11,     1,     1,     2,     1,     7,     9,
       7,     7,     9,     7,     9,     7,     9,     7,    15,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     3,     1,
       3,     1,     3,     3,     1,     2,     2,     6,     1,     3,
       0,     4,     3,     1,     3,     3,     3,     2,     4,     2,
       2,     2,     0,     2,     2,     0,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     5,     7,     7,
       0,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     4,
       1,     1,     1,     1,     2,     2,     3,     3,     6,     3,
       3,     3,     3,     3,     5,     7,     6,     6,     6,     6,
       4,     8,     4,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     3,     1,     3,     0,     1,     4,     6,     4,
       3,     5,     5,     4,     6,     3,     2,     5,     5,     8,
       8,     8,     8,     2,     1,     2,     2,     2,     0,     3,
       5,     0,     0,     2,     4,     4,     4,     2,     2,     2,
       1,     1,     1,     2,     2,     3,     3,     0,     3,     0,
       3,     4,     3,     0,     2,     2,     0,     2,     0,     2,
       4,     5,     2,     0,     3,     3,     3,     3,     5,     6,
       4,     6,     4,     6,     4,     4,     5,     6,     3,     3,
       4,     5,     5,     5,     5,     5,     4,     4,     5,     5,
       5,     5,     5,     5,     5,     5,     6,     6,     6,     5,
       6,     8,     6,     6,     5,     6,     4,     5,     4,     4,
       5,     4,     5,     4,     5,     5,     5,     5,     6,     5,
       5,     6,     5,     5,     5,     4,     2,     3,     3,     1,
       2,     3,     2,     4,     3,     2,     3,     1,     2,     4,
       0,     3,     2,     1,     2,     3,     3,     3,     3,     2,
       3,     0,     5,     0,     5,     2,     2,     1,     4,     1,
       1,     0,     3,     2,     2,     2,     5,     2,     0,     3,
       0,     2,     2,     3,     2,     2,     3,     2,     2,     2,
       1,     3,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       2,     3,     2,     3,     3,     4,     4,     2,     2,     2,
       3,     3,     3,     2,     3,     3,     3,     4,     2,     2,
       1,     0,     2,     3,     1,     0,     1,     2,     0,     2,
       0,     1,     3,     0,     0,     2,     0,     3,     0,     3,
       0,     3,     3,     1,     0,     4,     6,     6,     6,     7,
       6,     7,     5,     0,     2,     3,     2,     3,     3,     2,
       3,     2,     2,     3,     3,     5,     4,     4,     2,     1,
       2,     4,     2,     2,     0,     3,     5,     0,     0,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     3,     4,
       3,     2,     2,     1,     1,     1,     1,     1,     0,     3,
       0,     3,     4,     6,     6,     2,     3,     3,     5,     5,
       4,     2,     3,     3,     3,     1,     2,     4,     3,     3,
       3,     2,     2,     2,     2,     2,     1,     3,     0,     2,
       0,     3,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     1,     2,     2,     2,     1,     2,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 806 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4013 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 807 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4019 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 820 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 4030 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 830 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 4036 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 831 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 4044 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 838 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 4050 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 839 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 4056 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 840 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 4062 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 848 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = !!(yyvsp[0].i); }
#line 4068 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 849 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4074 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 850 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4080 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 851 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4086 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 852 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4092 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 853 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4098 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 860 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 4107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 867 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 4113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 868 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 4119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 872 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 4128 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 880 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 4134 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 884 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 4143 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 888 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.i) = ipa_masklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 4152 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 895 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 4162 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 904 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 4171 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 911 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 912 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 918 "cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 4194 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 927 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4200 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 928 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 4206 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 932 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = f;
   }
#line 4216 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 937 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 4222 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 938 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 4228 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 942 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4234 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 943 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4240 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 947 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 4246 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 948 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 4252 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 952 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 4258 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 953 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 4264 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 954 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 4270 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 955 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 4276 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 956 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 4282 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 957 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 4288 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 958 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 4294 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 959 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 4300 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 960 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 4306 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 966 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 4312 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 967 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = fileno(f);
   }
#line 4322 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 977 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 4328 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 978 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 4334 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 979 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 4340 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 980 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 4346 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 983 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 4352 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 984 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 4358 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 985 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 4364 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 986 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 4370 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 987 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 4376 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 988 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 4382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 998 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_debug = (yyvsp[0].i); }
#line 4388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 999 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_limit = (yyvsp[0].i32); }
#line 4394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 1000 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_warning = (yyvsp[0].i32); }
#line 4400 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 1001 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_timeout = ((yyvsp[0].i32) + 999999) TO_S; }
#line 4406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1010 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 4412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1013 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 4418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1020 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 4424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1023 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 4430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1026 "cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 4436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1029 "cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 4442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1032 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1037 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1038 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 4460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1039 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4466 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1047 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1052 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 4478 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1053 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 4484 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1057 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4490 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1058 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4499 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1062 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 4511 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1069 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4517 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1070 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4523 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1071 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 4535 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1083 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4541 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1088 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4550 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1092 "cf-parse.y" /* yacc.c:1646  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4562 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1106 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 4568 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1107 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 4574 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1121 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4580 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1122 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 4586 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1126 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4592 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1127 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[-1].x)); }
#line 4598 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1129 "cf-parse.y" /* yacc.c:1646  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4610 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1136 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
#ifndef IPV6
     else if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 4625 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1158 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 4631 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1159 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 4637 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1160 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 0; }
#line 4643 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1161 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 1; }
#line 4649 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1166 "cf-parse.y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 4655 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1172 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4661 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1173 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4667 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1177 "cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 4677 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1185 "cf-parse.y" /* yacc.c:1646  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 4685 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1191 "cf-parse.y" /* yacc.c:1646  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 4693 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1205 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 4699 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1206 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 4705 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1210 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 4716 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1216 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 4725 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1220 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1229 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1240 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 4760 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1244 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 4766 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1245 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 4772 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1246 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 4778 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1247 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 4784 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1248 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 4790 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1249 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 4796 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1250 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 4802 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1251 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 4808 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1252 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 4814 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1253 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->table = (yyvsp[0].r); }
#line 4820 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1254 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 4826 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1255 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 4832 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1259 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 4838 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1261 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 4844 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1262 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 4850 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1266 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4856 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1267 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 4862 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1268 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 4868 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1269 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 4874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1270 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4880 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1274 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 4891 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1280 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; }
#line 4897 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1284 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 4906 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1292 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 4912 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1293 "cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 4918 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1301 "cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 4928 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1309 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 4934 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1310 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4940 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1311 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4946 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1315 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 4952 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1316 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 4958 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1330 "cf-parse.y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 4964 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1332 "cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 4974 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1344 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 4980 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1345 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 4986 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1351 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 4995 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1361 "cf-parse.y" /* yacc.c:1646  */
    { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 5001 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1365 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 5011 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1379 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5017 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1380 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5023 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1381 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5029 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1386 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1390 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 5041 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1391 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 5047 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1392 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 5053 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1393 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 5059 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1394 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 5065 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1395 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 5071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1401 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1402 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5083 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1403 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5089 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1408 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5095 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1412 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 5101 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1413 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 5107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1434 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->length = strlen((yyvsp[0].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 5129 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1454 "cf-parse.y" /* yacc.c:1646  */
    { }
#line 5135 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1455 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 5141 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1456 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 5147 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1457 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 5153 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1458 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 5159 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1459 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[-2].time); }
#line 5165 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1460 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = this_p_item->accto = (yyvsp[-2].time); }
#line 5171 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1461 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 5177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1462 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->alg = (yyvsp[-2].i); }
#line 5183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1466 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_MD5; }
#line 5189 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1467 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA1; }
#line 5195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1468 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA256; }
#line 5201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1469 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA384; }
#line 5207 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1470 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA512; }
#line 5213 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1471 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_MD5; }
#line 5219 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1472 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA1; }
#line 5225 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1473 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA256; }
#line 5231 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1474 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA384; }
#line 5237 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1475 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA512; }
#line 5243 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1482 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 5249 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1485 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 5255 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1488 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 5261 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1491 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 5267 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1495 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5273 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1499 "cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 5279 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1502 "cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 5285 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1506 "cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 5291 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1509 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 5301 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1514 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 5312 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1520 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 5324 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1527 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 5334 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1532 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5344 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1537 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5354 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1542 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 5363 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1546 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 5372 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1550 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 5381 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1554 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1563 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5408 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1571 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 5417 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1575 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 5426 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1582 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 5432 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1583 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_EXPORT; }
#line 5438 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1584 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 5444 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1590 "cf-parse.y" /* yacc.c:1646  */
    { roa_show((yyvsp[-1].ro)); }
#line 5450 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1593 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 5462 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1600 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 5474 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1607 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 5483 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1611 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5493 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1619 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 5499 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1620 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 5505 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1621 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 5511 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1627 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 5517 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1630 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 5525 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1633 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 5531 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1634 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 5537 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1635 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 5543 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1636 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 5549 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1637 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 5555 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1638 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 5561 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1639 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 5567 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1644 "cf-parse.y" /* yacc.c:1646  */
    {
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 5577 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1649 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1658 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1665 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1672 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5614 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1680 "cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 5620 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1682 "cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 5626 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1684 "cf-parse.y" /* yacc.c:1646  */
    { io_log_dump(); cli_msg(0, ""); }
#line 5632 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1686 "cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 5638 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1688 "cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 5644 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1690 "cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 5650 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1692 "cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 5656 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1694 "cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 5662 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1697 "cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 5668 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1700 "cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 5677 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1706 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5683 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1707 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5689 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1708 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5695 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1712 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 5701 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1713 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 5710 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1720 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_disable, 1, 0); }
#line 5716 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1722 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_enable, 1, 0); }
#line 5722 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1724 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_restart, 1, 0); }
#line 5728 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1726 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 5734 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1728 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 5740 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1730 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 5746 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1734 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 5752 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1738 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 5758 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1741 "cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 5764 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1744 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5770 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1745 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5776 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1746 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5782 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1750 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5788 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1751 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5794 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1752 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5800 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1760 "cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 5806 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1761 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 5817 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1770 "cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 5823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1774 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 5829 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1775 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 5835 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1776 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 5841 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1777 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PREFIX; }
#line 5847 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1778 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 5853 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1779 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 5859 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1780 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 5865 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1781 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_LC; }
#line 5871 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1782 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 5877 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1783 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 5883 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1784 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 5889 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1785 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 5895 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1786 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 5901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1787 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_LCLIST; }
#line 5907 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1788 "cf-parse.y" /* yacc.c:1646  */
    {
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 5931 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1810 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 5944 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1821 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5950 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1822 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5959 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1829 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 5965 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1830 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5974 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1837 "cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 5985 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1846 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 5994 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1854 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 6020 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1878 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 6026 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1879 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 6032 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1883 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 6047 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1896 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 6056 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1899 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name);
     cf_pop_scope();
   }
#line 6067 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1912 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6073 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1913 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 6079 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1916 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 6085 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1917 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 6091 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1921 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 6099 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1924 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 6107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1933 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 6113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1946 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1947 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6125 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1948 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6131 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1949 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6137 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1950 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.v) = f_eval((yyvsp[-1].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 6146 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1954 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!cf_symbol_is_constant((yyvsp[0].s))) cf_error("%s: constant expected", (yyvsp[0].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[0].s)->def);
   }
#line 6156 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1962 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6162 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1963 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 6168 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1964 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6174 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1965 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6180 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1966 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6186 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1970 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 6192 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1973 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6198 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1974 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6204 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1975 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6210 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1976 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6216 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1977 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6222 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1978 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6228 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1979 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6234 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1980 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6240 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1981 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
#line 6246 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1983 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-9].i32), (yyvsp[-3].i32), (yyvsp[-7].i32), (yyvsp[-1].i32)); }
#line 6252 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1987 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 6258 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1988 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 6264 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1989 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6270 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1990 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 6276 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1994 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6282 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1995 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6288 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1996 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 6294 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2000 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6300 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2001 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6306 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2002 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6312 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2003 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6318 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2004 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6324 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2005 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6330 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2006 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
#line 6336 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2008 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-13].i32), (yyvsp[-5].i32), (yyvsp[-11].i32), (yyvsp[-3].i32), (yyvsp[-9].i32), (yyvsp[-1].i32)); }
#line 6342 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2015 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6348 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2016 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6354 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2023 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6360 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2024 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6366 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2029 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6372 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2034 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6378 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2038 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 6387 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2045 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6393 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2046 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 6399 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2047 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 6405 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2048 "cf-parse.y" /* yacc.c:1646  */
    {
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 6414 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2055 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6420 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2056 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6426 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2059 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 6432 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2060 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 6444 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2067 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 6456 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2079 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6462 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6468 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2084 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6474 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2085 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6480 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2089 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6486 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2090 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[-3].i); (yyval.h)->val2 = (yyvsp[-1].i); }
#line 6492 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2091 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6498 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2092 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; }
#line 6504 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2093 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 6510 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2094 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6516 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2098 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6522 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2099 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6528 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2100 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6534 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2104 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 6540 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2105 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 6546 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2106 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 6552 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2107 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 6558 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2108 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6564 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2109 "cf-parse.y" /* yacc.c:1646  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6570 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2110 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 6576 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2111 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 6582 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2112 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 6588 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2113 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 6594 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2114 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[0].h); (yyval.x)->a1.p = val; }
#line 6600 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2118 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6606 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2119 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6612 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2120 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_lc((yyvsp[-5].x), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6618 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2134 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6643 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2157 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 6660 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2171 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
#line 6666 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2172 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
#line 6672 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2173 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
#line 6678 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2174 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
#line 6684 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2175 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
#line 6690 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2176 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
#line 6696 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2177 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
#line 6702 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2178 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
#line 6708 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2179 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
#line 6714 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2180 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
#line 6720 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2184 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6726 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2185 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6732 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2186 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6738 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2187 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6744 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2188 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6750 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2189 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6756 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2190 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6762 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2191 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6768 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2192 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6774 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2193 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6780 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2194 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6786 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2195 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6792 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2196 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6798 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2197 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6804 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2198 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','~');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6810 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2199 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[0].x); }
#line 6816 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2200 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6822 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2202 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6828 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2203 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6834 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2204 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6840 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2206 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
#line 6846 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2208 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = 'a'; }
#line 6852 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2210 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = P('e','a'); }
#line 6858 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2212 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 6864 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2213 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6870 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2214 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6876 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2215 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6882 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2216 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6888 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2217 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','L'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6894 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2227 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
#line 6900 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2228 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
#line 6906 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2229 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
#line 6912 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2230 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_LCLIST; }
#line 6918 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2231 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6924 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2232 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 6930 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2233 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 6936 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2234 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 6942 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2236 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 6948 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2237 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6954 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2242 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6979 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2265 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 6985 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2266 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 6991 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2267 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 6997 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2268 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 7003 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2269 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 7009 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2270 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 7015 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2274 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 7021 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2277 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7027 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2278 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7033 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2279 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 7044 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2287 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 7056 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2294 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 7068 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7074 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2304 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7080 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2308 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7091 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2314 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7106 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2324 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 7120 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2333 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7131 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2339 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7141 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2344 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7153 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2351 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7163 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2356 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-2].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
#line 7174 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2362 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 7180 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2363 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 7186 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2364 "cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 7197 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2372 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].x)); }
#line 7203 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2373 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 7209 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2374 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 7215 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2375 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 7221 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2376 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 7227 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2383 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 7241 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2410 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
#line 7258 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2424 "cf-parse.y" /* yacc.c:1646  */
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
#line 7281 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2444 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7287 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2445 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 7293 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2446 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7299 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2447 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 7305 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2448 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 7311 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2449 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 7317 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2450 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->auth_type = (yyvsp[0].i); }
#line 7323 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2451 "cf-parse.y" /* yacc.c:1646  */
    {}
#line 7329 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2455 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_NONE; }
#line 7335 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2456 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_SIMPLE; }
#line 7341 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2457 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
#line 7347 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2458 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
#line 7353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2459 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
#line 7359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
#line 7365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2478 "cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 7371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2482 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 7377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2483 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 7383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2484 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 7389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2488 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 7395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2489 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 7401 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2493 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7407 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2494 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 7413 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2498 "cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 7433 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2517 "cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 7439 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2522 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->setkey = 1;
 }
#line 7467 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2549 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number");  }
#line 7473 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2550 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 7479 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2556 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7485 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2557 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7491 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 2559 "cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 7502 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2565 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 7508 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2566 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 7514 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2567 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = 1; }
#line 7520 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2568 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = 1; }
#line 7526 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2569 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 7532 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2570 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 7538 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2571 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 7544 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2572 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 7550 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2573 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 7556 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2574 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 7562 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2575 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 7568 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2576 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 7574 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2577 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 7580 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2578 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 7586 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2579 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 7592 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2580 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 7598 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2581 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 7604 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2582 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 7610 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2583 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 7616 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2584 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 7622 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2585 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 7628 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2586 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 7634 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2587 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 7640 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2588 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 7646 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2589 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 7652 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2590 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 7658 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2591 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 7664 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2592 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 7670 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2593 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 7676 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2594 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 7682 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2595 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 7688 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2596 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 7694 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2597 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 7700 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2598 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 7706 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2599 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 7712 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2600 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 7718 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2601 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 7724 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2602 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 7730 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2603 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
#line 7741 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2609 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 7747 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2610 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 7753 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2611 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 7759 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2612 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 7765 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2613 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 7771 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2614 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 7777 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2615 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 7783 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2616 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 7789 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2617 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 7795 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2618 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 7801 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2619 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 7807 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2620 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 7813 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2621 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 7819 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2622 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 7825 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2623 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 7831 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2634 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
#line 7843 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2650 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 7849 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2651 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 7855 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2652 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 7861 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2653 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 7867 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2654 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 7873 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2655 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 7879 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2656 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 7885 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2660 "cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 7903 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2675 "cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 7909 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2684 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 7915 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2685 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 7921 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2686 "cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 7927 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2687 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 7933 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2688 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 7939 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2689 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 7945 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2690 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 7951 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2691 "cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 7957 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2692 "cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 7963 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2693 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 7969 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2694 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 7975 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2706 "cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 7986 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2720 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 7992 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2721 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 7998 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2722 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 8004 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2726 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8010 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2727 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8016 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2736 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8022 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2737 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8028 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 2738 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8034 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2739 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8040 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2740 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8046 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2741 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8052 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 2742 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 8058 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2743 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8064 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2744 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8070 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2745 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 8076 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2749 "cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 8097 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2768 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 8103 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2769 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8109 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2770 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 8115 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2771 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8121 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2772 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8127 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2773 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8133 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2774 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8139 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2775 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8145 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2776 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8151 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2777 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8157 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2778 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8163 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2779 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8169 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2780 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8175 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2781 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8181 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2782 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8187 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2783 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 8193 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2784 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 8199 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2785 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8205 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2786 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 8211 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2787 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 8217 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2788 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 8223 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2789 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 8229 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2790 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 8235 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2791 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 8241 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2793 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 8247 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2794 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8253 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2795 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8259 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2796 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 8265 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2797 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 8271 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2798 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 8277 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2799 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 8283 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2800 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 8289 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2801 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 8295 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2802 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 8301 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2803 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 8307 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2804 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 8313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2805 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 8319 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2806 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 8325 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2817 "cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 8336 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2827 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 8342 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2828 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 8348 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2837 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 8354 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2838 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 8360 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2842 "cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 8371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2851 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 8395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2874 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8401 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2878 "cf-parse.y" /* yacc.c:1646  */
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 8407 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2892 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8413 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2897 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 8419 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2903 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 8425 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 2906 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8431 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2909 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8437 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2914 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 8443 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2917 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 8449 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2922 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 8455 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2925 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 8461 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2929 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 8467 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2932 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 8475 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2935 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 8481 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2936 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 8487 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2937 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 8493 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2938 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 8499 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2939 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 8505 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 2940 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 8511 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 2941 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 8517 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 2942 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 8523 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 2948 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 8532 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 2957 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 8542 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 2962 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 8548 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 2963 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 8554 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 2970 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
#line 8569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 2983 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 8575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 2984 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 8581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 2985 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[0].i); }
#line 8587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 2999 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
#line 8613 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 3022 "cf-parse.y" /* yacc.c:1646  */
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 8646 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 3052 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 8652 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 3053 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 8658 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 3054 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 8664 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3055 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->passive = (yyvsp[0].i); }
#line 8670 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 3056 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->address = (yyvsp[0].a); }
#line 8676 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 3057 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 8682 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3058 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 8691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3062 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 8697 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3063 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 8703 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3064 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 8709 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3065 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 8715 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3066 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->update_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 8721 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3067 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->timeout_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 8727 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->garbage_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 8733 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3069 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 8739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3070 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 8745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3071 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 8751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3072 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 8757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3073 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 8763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3074 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 8769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3075 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = 2; }
#line 8775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3076 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 8781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 3077 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 8787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3078 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 8793 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3079 "cf-parse.y" /* yacc.c:1646  */
    { rip_check_auth(); }
#line 8799 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3083 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_NONE; }
#line 8805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3084 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_PLAIN; }
#line 8811 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3085 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 8817 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3086 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 8823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3107 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 8829 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 3110 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 8835 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3116 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 8844 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3125 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 8850 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3126 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 8856 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3127 "cf-parse.y" /* yacc.c:1646  */
    { static_route_finish(); }
#line 8862 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3130 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
#line 8874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3140 "cf-parse.y" /* yacc.c:1646  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
#line 8888 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3149 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 8897 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 3153 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
   }
#line 8905 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3159 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->mp_next = this_srt_nh; }
#line 8911 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3160 "cf-parse.y" /* yacc.c:1646  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 8917 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3164 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 8927 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3169 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 8938 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3175 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 8946 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3178 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 8955 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3183 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 8961 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 3184 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 8967 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3185 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 8973 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3186 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 8979 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3187 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 8985 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3191 "cf-parse.y" /* yacc.c:1646  */
    { *this_srt_last_cmd = (yyvsp[0].x); this_srt_last_cmd = &((yyvsp[0].x)->next); }
#line 8991 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3192 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->use_bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 8997 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3207 "cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 9003 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 892:
#line 3215 "cf-parse.y" /* yacc.c:1646  */
    { bgp_check_config(BGP_CFG); }
#line 9009 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 893:
#line 3215 "cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 9015 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 904:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 9021 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 905:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 9027 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 906:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 9033 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 907:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 9039 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 908:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 9045 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 909:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 9051 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 910:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 9057 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 911:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 9063 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 912:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 9069 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 913:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 9075 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 914:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 9081 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 915:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 9087 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 916:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 9093 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 917:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 9099 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 918:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 9105 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 919:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 9111 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 920:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 9117 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 921:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 9123 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 922:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
#line 9129 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 923:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
#line 9135 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 924:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
#line 9141 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 925:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
#line 9147 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 926:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
#line 9153 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 927:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
#line 9159 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 928:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
#line 9165 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 929:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
#line 9171 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 930:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
#line 9177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 931:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
#line 9183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 932:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
#line 9189 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 933:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
#line 9195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 934:
#line 3219 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 9201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 935:
#line 3219 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 9207 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 936:
#line 3220 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 9213 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 937:
#line 3221 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 9219 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 938:
#line 3222 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 9225 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 939:
#line 3223 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 9231 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 940:
#line 3224 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 9237 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 941:
#line 3225 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 9243 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 942:
#line 3226 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 9249 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 943:
#line 3227 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 9255 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 944:
#line 3228 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 9261 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 945:
#line 3229 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 9267 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 946:
#line 3230 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 9273 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 947:
#line 3231 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(EAP_BGP, BA_LARGE_COMMUNITY)); }
#line 9279 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 948:
#line 3231 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 9285 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 949:
#line 3231 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 9291 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 950:
#line 3231 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 9297 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 951:
#line 3231 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 9303 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 952:
#line 3231 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 9309 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 953:
#line 3231 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 9315 "cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 9319 "cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3233 "cf-parse.y" /* yacc.c:1906  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

